'<ADbasic Header, Headerversion 001.001>
' Foldings                       = 74,78,86,134,200,219,356,399,531,589,998,1299,1373,1402,1431,1682,2105,2743
'<Header End>
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--INC--PRO
'
'###############################################################
'#                        ADwpEXT.inc                          #
'#              INCLUDE-file for ADwin-Pro-system              #
'###############################################################
'#                                                             #
'# Contents: Summary of functions and procedures               #
'#           for ADwin-ext-modules.                            #
'#                                                             #
'#  25.05.1997  OL   creation                                  #
'#  08.04.1998  OL   changes for ADSP (ADbasic 3)              #
'#  08.04.1999  OL   changes for seriel interface              #
'#  12.06.1999  OL   commands for CAN interface                #
'#  29.07.1999  OL   commands for Profibus interface           #
'#  06.08.1999  OL   29 Bit-ID for CAN interface               #
'#  24.01.2000  OL   commands for Anybus-S                     #
'#  04.08.2000  OL   changes for CAN-2                         #
'#  22.08.2000  OL   RS485 functions check_shift_reg and       #
'#                                    rs485_send               #
'#  20.03.2001  OL   PROFIBUS set_write_buffer ;               #
'#                             interne Schleife um 1 verkrzt  #
'#  16.11.2001  JK   replacements because ADbasic keywords :   #
'#                      register     ->   register_no          #
'#                      fifo_empty   ->   fifo_status          #
'#  16.11.2001  JK   1st line : ADBASIC-SYSTEM_FILE...         #
'#  19.11.2001  JK   added one NOP to POKE_NOP  => now         #
'#                      identical with other PRO include files #
'#  13.05.2002  OL   new command: get_line_status (CAN-LS)     #
'#  29.07.2002  OL   switching big functions (PM) to library   #
'#                   functions to save program memory          #
'#  18.10.2002  OL   combine includes for DSP and Transputer   #
'#  18.10.2002  OL   changes for T10 (ADbasic 4)               #
'#  28.01.2004  OL   optimized for smaler program-code         #
'#  13.05.2004  MF   bugfix RS RESET                           #
'#  24.05.2004  MF   bugfix get_line_status                    #
'#  03.02.2005  MF   NOT T11                                   #
'#  01.03.2005  MF   TC ISO                                    #
'#  14.04.2005  MF   ERROR WRONG PROCESSOR                     #
'#  29.04.2005  MF   TC ISO TYP N,E                            #
'#  16.06.2005  MF   make_lib=off                              #
'#  20.09.2005  MF   TC READ VOLTAGE                           #
'#  24.04.2006  MF   TCJ_DIG_TO_TEMP                           #
'#  24.04.2006  MF   TCK_DIG_TO_TEMP                           #
'#  02.05.2006  MF   PT100_DIG_TO_TEMP                         #
'#  02.05.2006  MF   PT100_DIG_TO_R                            #
'#  20.06.2006  MF   TC_READ_B                                 #
'#  13.09.2006  MF   LS-BUS                                    #
'#  17.10.2006  MF   LS-BUS optimized for smaler program-code  #
'#  08.01.2007  OL   bugfix Anybus handshake                   #
'#  09.04.2007  MF   designed for ADbasic 5                    #
'#  14.06.2007  OL   New sub: Read_Msg_Con                     #
'#  18.02.2009  MF   Read_Msg_Con                              #
'#  19.02.2009  MF   Transmit_Status                           #
'#  24.03.2009  MF   '''+                                      #
'#  06.04.2010  MF   can_msg ()                                #
'#  10.08.2010  MF   syntax_highlight AD,DA,DIO,EXT            #
'#  29.11.2010  MF   transmit_status hide                      #
'#  31.01.2011  MF   round=>system_round                       #
'#  30.10.2012  MF   LS Bus Error Code                         #
'#  15.05.2013  MF   at dm_local lib                           #
'#  20.09.2016  MF   transmit_status hide removed              #
'#                                                             #
'# Attention:                                                  #
'#   - Do not copy the first source line (containing           #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !              #
'#     Otherwise the Syntax color may be not correct.          #
'#   - This includefile requires ADbasic 4.0 or higher!        #
'#   - arrays which should be transfered to lib-functions must #
'#     be declared at external DRAM                            #
'#                                                             #
'###############################################################

#IF PROZESSOR=T11 THEN
#error("This include file can only be used with the processor T2, T4, T5, T8, T9 or T10.")
#ELSE

'''system constant which can be used by:
'''SetLED,CheckLED
'''EventEnable,EventSource
'''SyncEnable,SyncStat
#DEFINE EXT 0C0h  'EXT - MASK 

#IF  PROZESSOR = ADSP THEN

'<REGION> Declaration
#if make_lib=off then
dim toggle_flag[5] as Long          ' Anybus Togglebit ''<HIDE>
'''The first 8 elements of the array contain the data bytes 1...8 and the 9th array element the amount of valid data bytes of the message. 
'''Here a value from 0 to 8 must be entered.
'''The data bytes use only the bits 7...0 in the array elements, bits 31...8 are ignored
dim CAN_msg[9] as Long at DRAM_EXTERN  ' array with 9 elements
#endif

' element 1 to 8 for databyte 1 to 8 in CAN-Frame
' element 9 for the number of databytes in CAN-Frame

  
#IF PROZESSOR = T9 THEN
#define DL              20400000H ''<HIDE>
#define DH              20400010H ''<HIDE>
#define DLX             20400020H ''<HIDE>
#define DHX             20400030H ''<HIDE>
#define ADWR            20400060H ''<HIDE>
#define ADRD            20400070H ''<HIDE>
#define cpu_EVENT       204000F0H ''<HIDE>
#define watchdog        204001D0H ''<HIDE>
#define WD_TIMER        204001E0H ''<HIDE>
#define cpu_LED         204001F0H ''<HIDE>
#define d32             20400180h ''<HIDE>
#define SYSTEM_HP_TIMER 204003F0H ''<HIDE>
#ENDIF
#IF PROZESSOR = T10 THEN
#define DL              20800000H ''<HIDE>
#define DH              20800010H ''<HIDE>
#define DLX             20800020H ''<HIDE>
#define DHX             20800030H ''<HIDE>
#define ADWR            20800060H ''<HIDE>
#define ADRD            20800070H ''<HIDE>
#define cpu_EVENT       208000F0H ''<HIDE>
#define watchdog        208001D0H ''<HIDE>
#define WD_TIMER        208001E0H ''<HIDE>
#define cpu_LED         208001F0H ''<HIDE>
#define d32             20800180h ''<HIDE>
#define SYSTEM_HP_TIMER 208003F0H ''<HIDE>
#ENDIF

'Profibus slave adresses (DPRAM)
'Handshakeregisters
#define app_ind     7feH ''<HIDE>
#define any_ind     7ffH ''<HIDE>
'<ENDREGION>

'<REGION> Helper function
'***************************************************************
' If the processor is a T9 this procedure disables the interrupt,
' so that a process with low priority can not be interrupted.
' The procedure is used to protect a read or a write cycle.
'***************************************************************
SUB SUB_BEGIN_CRITICAL_SECTION() ''<HIDE>
#IF PROZESSOR = ADSP THEN
#IF PRIORITAET = LOW
  BEGIN_CRITICAL_SECTION
#ENDIF
#ENDIF
ENDSUB

'***************************************************************
' This procedure enables the interrupt.
' (see SUB_BEGIN_CRITICAL_SECTION)
'***************************************************************
SUB SUB_END_CRITICAL_SECTION() ''<HIDE>
#IF PROZESSOR = ADSP THEN
#IF PRIORITAET = LOW
  END_CRITICAL_SECTION
#ENDIF
#ENDIF
ENDSUB
#IF PROZESSOR = T9 THEN
import adwpext_lib.li9
import tc.li9
#ENDIF
#IF PROZESSOR = T10 THEN
import adwpext_lib.lia
import tc.lia
#ENDIF

'*****************************************************************
' Procedure inserts 5 nop's after a poke instruction if the used processor
' is an ADSP.
'*****************************************************************
SUB poke_nop(adress,value) ''<HIDE>
#IF PROZESSOR = T9 THEN
  poke(adress,value)
  nops(5)
#ELSE
#IF PROZESSOR = T10 THEN
  poke(adress,value)
  nops(10)
#ELSE
  poke(adress,value)
#ENDIF
#ENDIF
ENDSUB

'***************************************************************
' Procedure inserts 1 nop if the processor is a T9.
'***************************************************************

SUB NOP_T9()''<HIDE>
#IF PROZESSOR = T9 THEN
  NOP
#ENDIF
#IF PROZESSOR = T10 THEN
  nops(2)
#ENDIF
endsub
'<ENDREGION>

'<REGION> Thermoouple
'-----------------Thermocouple

'***********************************************
''' Sets the thermocouple multiplexer.
''' module: module address (0..255)
''' channel: multiplexer channel (1..16)
'''*********************************************
SUB TC_Select(module,channel)
  DIM adr,adcnr as Long
  adr = 0D0H OR (SHIFT_LEFT(module,8))
  SUB_BEGIN_CRITICAL_SECTION()
  poke (ADWR, adr)
  nop_t9
  poke_nop (DLX, channel-1)
  SUB_END_CRITICAL_SECTION()
ENDSUB
'<ENDREGION>

'<REGION> CAN
'------------------CAN

'***************************************************************
'''Checks if there is a new frame in the selected
'''+message object. If there is a new frame all databytes are read
'''+and then written to the array "can_msg".
'''+The number of dadabytes is written to the element 9 of the array "can_msg".
'''+The return value of the function is the identifier of the frame.
'''+If there is no new frame in the message box the return value is -1.
'''module: module address (0..255)
'''channel: number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
'''msg_no: number of the message object
'''*************************************************************
function Read_Msg(module,channel,msg_no) as Long
  read_msg=lib_read_msg(module,channel,msg_no,can_msg)
endfunction


'***************************************************************
'''Checks if there is a new frame in the selected
'''+message object. If there is a new frame all databytes are read
'''+and then written to the array "can_msg".
'''+The number of dadabytes is written to the element 9 of the array "can_msg".
'''+The return value of the function is the identifier of the frame.
'''+If there is no new frame in the message box the return value is -1.
'''+Checks the consistens of the data and if they ars not consistent
'''+the datas will be reread.
'''module: module address (0..255)
'''channel: number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
'''msg_no: number of the message object
'''*************************************************************
function Read_Msg_Con(module,channel,msg_no) as Long
  read_msg_Con=lib_read_msg_Con(module,channel,msg_no,can_msg)
endfunction


'***************************************************************
'''Transmits a frame.
'''+The databytes and the number of databytes have to be written in the
'''+array "can_msg" before this subroutine is activated.
'''+After this subroutine the frame is transmitted as soon as the
'''+CAN-bus allows it.
'''module: module address (0..255)
'''channel: number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
'''msg_no: number of the message object
'''*************************************************************
sub Transmit(module,channel,msg_no)
  lib_transmit(module,channel,msg_no,can_msg)
endsub


'******************************************************************************
''' Checks if a Messagebox is ready to send (The last Message is already sent).
'''+ return: 
'''+      0 = ready to send
'''+      1 = not ready to send
''' module: module address (0..255)
''' channel: number of the CAN interface on the CAN module
''' msg_no: number of the message object
'''****************************************************************************
Function Transmit_Status(module,channel, msg_no) as long 
  Transmit_Status = shift_right(Get_CAN_Reg(module,channel,((msg_no) * 10h) + 1), 5) and 1    ' Control 1register
EndFunction



'***************************************************************
'''Sets a register of the CAN-controller.
'''module: module address (0..255)
'''channel: number of the CAN interface on the CAN module
'''regno: register which should be set
'''value: value which should be written to the register.
'''*************************************************************
sub Set_CAN_Reg(module,channel,regno,value)
  dim adr1 as Long
  dim adr2 as Long
  adr1 = 0c0h or (shift_left(module, 8)) or ((channel-1)*8)
  adr2 = adr1 or (1+((channel-1)*8))
  SUB_BEGIN_CRITICAL_SECTION()
  poke(adwr ,adr2)
  nop_t9
  poke_nop(dlx ,regno)
  poke(adwr ,adr1)
  nop_t9
  poke_nop(dlx ,value)
  SUB_END_CRITICAL_SECTION()
endsub


'***************************************************************
'''Reads a register of the CAN-controller.
'''+return value: value of the register
'''module: module address (0..255)
'''channel: number of the CAN interface on the CAN module
'''+          (also necessary if the module provides only one channel)
'''regno: register to read
'''*************************************************************
Function Get_CAN_Reg(module,channel,regno) as Long
  dim adr1 as Long
  dim adr2 as Long
  adr1 = 0c0h or (shift_left(module, 8)) or ((channel-1)*8)
  adr2 = adr1 or (2+((channel-1)*8))
  SUB_BEGIN_CRITICAL_SECTION()
  poke(adwr ,adr2)
  nop_t9
  poke_nop(dlx ,regno)
  sleep(6)
  poke_nop(adrd ,adr1)
  get_can_reg = peek(dlx) and 255
  SUB_END_CRITICAL_SECTION()
endfunction


'***************************************************************
'''Reads the register where the bus error pin of the tranceiver
'''+is stored.
'''+The register is set when the a bus error occurs and is reset by
'''+reading the register.
'''+return value : 
'''+               0 = no error
'''+               1 = error
'''+Attention: This command is only for low-speed CAN
'''module: module address (0..255)
''' channel: number of the CAN interface on the CAN module
'''       (also necessary if the module provides only one channel)
'''*************************************************************
Function Get_Line_Status(module,channel) as Long
  dim adr as Long
  adr =  0c0h or shift_left(module, 8) or (3Dh - channel)
  SUB_BEGIN_CRITICAL_SECTION()
  poke_nop(ADRD, adr)
  get_line_status = peek(DLX)
  SUB_END_CRITICAL_SECTION()
endfunction
'<ENDREGION>

'<REGION> RSxxx
'------------------RS
'***********************************************
''' Sets a register of the seriell controller
''' module: module address (0..255)
''' register_no: register on the serial controller
''' value: value for the selected register
'''*********************************************
sub Set_RS(module,register_no,value)
  dim adr as Long
  adr = (0c0h + register_no) or (shift_left(module, 8))
  SUB_BEGIN_CRITICAL_SECTION()
  poke (adwr, adr)
  nop_t9
  poke_nop (dlx, value)
  SUB_END_CRITICAL_SECTION()
endsub

'***********************************************
''' Reads the value of a register of the serial controller.
''' module: dip switch address (0..255)
''' register_no: register on the serial controller
'''********************************************
FUNCTION Get_RS(module, register_no) AS Long
  DIM adr as Long
  adr = (0c0h + register_no) or (shift_left(module,8))
  SUB_BEGIN_CRITICAL_SECTION()
  poke_nop(adrd, adr)
  Get_Rs = peek(DLX)
  SUB_END_CRITICAL_SECTION()
ENDFUNCTION

'***************************************************************
''' Resets the serial interface module.
''' module: module address (0..255)
'''*************************************************************
sub RS_Reset(module)
  dim adr as Long
  set_rs(module,23, 1)            ' reset aktiv
  set_rs(module,23, 0)            ' reset not aktiv
endsub
'<ENDREGION>

'<REGION> Anybus
'-------------------Anybus

function Init_Slave(module,io_in,par_in,io_out,par_out,input_handling,output_handling,reserved) as Long
  init_slave = init_slave_lib(module,IO_in,par_in,IO_out,par_out,input_handling,output_handling,reserved)
endfunction
'*****************************************************************
''' Gets a byte from the DPRAM of a profibus-DP master or slave
''' module: module address (0..255)
''' byteno: number of the byte on the DPRAM
'''***************************************************************
function Get_Pro_Byte(module,byteno) as Long
  dim adr as Long
  adr = 80c0h or shift_left(module,13) or (byteno and 0ffffffc0h) *4h or (byteno and 63)
  SUB_BEGIN_CRITICAL_SECTION()
  poke_nop(adrd, adr)
  get_pro_byte=peek(dlx)
  SUB_END_CRITICAL_SECTION()
endfunction

'*****************************************************************
''' Sets a byte in the DPRAM of a profibus-DP master or slave
''' module: module address (0..255)
''' byteno: number of the byte on the DPRAM
''' value: value for the selected byte
'''***************************************************************
sub Set_Pro_Byte(module,byteno,value)
  dim adr as Long
  adr = 80c0h or shift_left(module,13) or (byteno and 0ffffffc0h) *4h or (byteno and 63)
  SUB_BEGIN_CRITICAL_SECTION()
  poke(adwr, adr)
  nop_t9
  poke_nop(dlx, value)
  SUB_END_CRITICAL_SECTION()
endsub

'******************************************************
''' Gives the information if the data in
'''+the out area has changed or not. If there is new data
'''+the return value is <> 0 else the return value is 0.
''' module: module address (0..255)
'''outsize: number of bytes of the out area.
'''****************************************************
Function Changed_Data(module,outsize) as Long
  dim loopsize as Long
  dim buffer as Long
  dim count as Long
  changed_data = 0
  loopsize = (outsize - 1)/8 + 1
  for count = 1 to loopsize
    buffer = get_pro_byte(module,(count + 7E3h))
    changed_data = changed_data or buffer
  next count
endfunction


'******************************************************
' Requests application access to DPRAM.
' The DPRAM consists of 3 parts. Each part equals a bit
' in the parameter array:
' Bit 0:   Anybus control registers
' Bit 1:   Output data 
' Bit 2:   Input data
' module: module address (0..255)
' area:
'******************************************************
sub Request_Access(module,area)
  toggle_flag[module+1] = get_pro_byte(module,any_ind) and 08H
  lib_request_access(module,area) 
endsub

'******************************************************
' Requests application access release to DPRAM.
' The DPRAM consists of 3 parts. Each part equals a bit
' in the parameter array:
' Bit 0:   Anybus control registers
' Bit 1:   Output data
' Bit 2:   Input data
'******************************************************
sub Request_Release_Access(module, area)
  toggle_flag[module+1] = get_pro_byte(module,any_ind) and 08H
  lib_request_release_access(module , area)
endsub


'******************************************************
' Checks access right. If bit is set the application has
' access right.
' The DPRAM consists of 3 parts. Each part equals a bit
' in the parameter array:
' Bit 0:   Anybus control registers
' Bit 1:   Output data
' Bit 2:   Input data
'******************************************************
function Check_Access(module) as Long
  if (toggle_flag[module+1] = get_pro_byte(module,any_ind) and 08H) then
    check_access = -1
  else
    check_access = get_pro_byte(module,any_ind) and 07h
  endif
endfunction

'*******************************************************
' Readss the input data from the DPRAM.
' module: module address (0..255)
' array[]: destination array for input data
' start: first byte (DPRAM)
' count: number of bytes
'*******************************************************
sub Get_Read_Buffer(module,array[],start,count)
  dim i as Long
  for i = start to (start + count - 1)
    array[i + 1 - start] = get_pro_byte(module,i)
  next i
endsub


'*******************************************************
' Writes the output data to the DPRAM
' module: module address (0..255)
' array[]: source array for input data
' start: first byte (DPRAM)
' count: number of bytes
'*******************************************************
sub Set_Write_Buffer(module,array[],start,count)
  dim i as Long
  for i = start to (start + count - 1)
    set_pro_byte(module,i,array[i+1])
  next i
endsub
'<ENDREGION>

'<REGION> Temperature conversion
'---------------------------------------------------------------
''' Converts digit from TC4/8/16 J to temperature.
''' dig_val: inputvalue
'''t_unit: 
'''+     1 = C
'''+     2 = F
'''-------------------------------------------------------------
FUNCTION TCJ_Dig_To_Temp(dig_val,t_unit) as Float
  TCJ_Dig_To_Temp = TC_CONVERT_TYP_J((dig_val - 32778) * 1.57758)
  IF (t_UNIT=2) THEN  'C -> F
    TCJ_Dig_To_Temp=(TCJ_DIG_TO_TEMP*1.8)+32
  ENDIF
ENDFUNCTION

''' Converts digit from TC4/8/16 K to temperature.
''' dig_val: inputvalue
''' t_unit: 
'''+         1 = C
'''+         2 = F
'''-------------------------------------------------------------
FUNCTION TCK_Dig_To_Temp(dig_val,t_unit) as Float
  TCK_Dig_To_Temp = TC_CONVERT_TYP_K((dig_val - 32778) * 1.234192)
  IF (t_UNIT=2) THEN  'C -> F
    TCK_DIG_TO_TEMP=(TCK_DIG_TO_TEMP*1.8)+32
  ENDIF
ENDFUNCTION


'---------------------------------------------------------------
''' Converts digit from PT-100 to temperature.
''' dig_val: inputvalue
''' unit 
'''+     1 = C
'''+     2 = F
'''-------------------------------------------------------------
FUNCTION PT100_Dig_To_Temp(dig_val,t_unit) AS Float
  DIM x AS Float
  x = (dig_val-32768)*20/65536
  IF (x <= 0) THEN
    PT100_Dig_To_Temp = ((((0.0002*x - 0.0032) * x + 0.0906) * x + 25.581) * x - 0.002)
  ELSE
    PT100_Dig_To_Temp = (0.1097*x + 25.536)*x + 0.0444
  ENDIF

  IF (t_unit = 2) THEN PT100_DIG_TO_TEMP = PT100_DIG_TO_TEMP*1.8 + 32
ENDFUNCTION

'---------------------------------------------------------------
''' Converts digit from PT-100 to resistor.
'''+ return r[ohm]
''' dig_val inputvalue
'''--------------------------------------------------------------
FUNCTION PT100_Dig_To_R(dig_val) AS Float
  PT100_DIG_TO_R = ((dig_val-32768)*200/65536)+100
ENDFUNCTION
'<ENDREGION>

'<REGION> TC_Read_x
'***************************************************************
'---------------------------------------------------------------
''' Reads value of tc iso TYP J  -210 C -> 1200 C.
''' module: module address (0..255)
''' channel: (1-8)
''' ret_type: 
'''+       0 = thermovoltage V
'''+       1 = C
'''+       2 = F
'''-------------------------------------------------------------
function TC_Read_J(module,channel,ret_type) as Float
  dim adr as Long
  dim value as Long
  dim spg as Long
  dim coldjunction as Long
  dim spg2 as Float

  adr = SHIFT_LEFT(module,8) or 0c0h or (channel-1)

  SUB_BEGIN_CRITICAL_SECTION
  poke_nop(ADRD, adr )
  value = peek(d32)
  SUB_END_CRITICAL_SECTION

  coldjunction=(shift_right(value,16)) AND 1FFFH
  if (coldjunction AND 1000H=1000H) then coldjunction=coldjunction or 0FFFFE000H

  spg=VALUE AND 0FFFFH 'thermovoltage 409.6 digit /mV
  if( spg AND 32768=32768) then spg=spg OR 0FFFF0000H

  spg2=spg *2.44140625 'thermovoltage => V
  spg2=spg2 +TC_CONVERT_TYP_J_INV((coldjunction/16))

  IF (ret_type>0) then 'convert
    TC_READ_J=TC_CONVERT_TYP_J(spg2) '-210 C->1200 C DIN EN 60584-1
  ELSE
    TC_READ_J=spg2
  endif

  if (ret_type=2) then  'C -> F
    TC_READ_J=(TC_READ_J*1.8)+32
  endif

endfunction

'---------------------------------------------------------------
''' Reads value of tc iso TYP K -200 C -> 1372 C.
''' module: module address (0..255)
''' channel: (1-8)
''' ret_type: 
'''+       0 = thermovoltage in V
'''+       1 = C
'''+       2 = F
'''-------------------------------------------------------------
function TC_Read_K(module,channel,ret_type) as Float
  dim adr as Long
  dim value as Long
  dim spg as Long
  dim coldjunction as Long
  dim spg2 as Float

  adr = SHIFT_LEFT(module,8) or 0c0h or (channel-1)

  SUB_BEGIN_CRITICAL_SECTION
  poke_nop(ADRD, adr )
  value = peek(d32)
  SUB_END_CRITICAL_SECTION

  coldjunction=(shift_right(value,16)) AND 1FFFH
  if (coldjunction AND 1000H=1000H) then coldjunction=coldjunction or 0FFFFE000H

  spg=VALUE AND 0FFFFH 'thermovoltage 409.6 digit /mV
  if( spg AND 32768=32768) then spg=spg OR 0FFFF0000H

  spg2=spg *2.44140625 'thermovoltage => V

  if (coldjunction<=400) then '<25 C
    spg2=spg2+(2.5055*coldjunction)
  else
    spg2=spg2+(2.56*(coldjunction-9.76))
  endif

  IF (ret_type>0) then 'convert
    TC_READ_K=TC_CONVERT_TYP_K(spg2) '-200 C -> 1372 C DIN EN 60584-1
  ELSE
    TC_READ_K=spg2
  endif

  if (ret_type=2) then  'C -> F
    TC_READ_K=(TC_READ_K*1.8)+32
  endif

endfunction


'---------------------------------------------------------------
''' Reads value of tc iso TYPE S -50 C -> 1768 C
''' module: module address (0...255)
''' channel: (1-8)
''' ret_type: 
'''+        0 = thermovoltage in V
'''+        1 = C
'''+        2 = F
'''-------------------------------------------------------------
function TC_Read_S(module,channel,ret_type) as Float
  dim adr as Long
  dim value as Long
  dim spg as Long
  dim coldjunction as Long
  dim spg2 as Float

  adr = SHIFT_LEFT(module,8) or 0c0h or (channel-1)

  SUB_BEGIN_CRITICAL_SECTION
  poke_nop(ADRD, adr )
  value = peek(d32)
  SUB_END_CRITICAL_SECTION

  coldjunction=(shift_right(value,16)) AND 1FFFH
  if (coldjunction AND 1000H=1000H) then coldjunction=coldjunction or 0FFFFE000H

  spg=VALUE AND 0FFFFH 'thermovoltage 409.6 digit /mV
  if(spg AND 32768=32768) then spg=spg OR 0FFFF0000H

  spg2=spg *2.44140625 'thermovoltage => V
  spg2=spg2 +TC_CONVERT_TYP_S_INV((coldjunction/16))

  IF (ret_type>0) then 'convert
    TC_READ_S=TC_CONVERT_TYP_S(spg2) '-50 C-> 1768 C DIN EN 60584-1
  ELSE
    TC_READ_S=spg2
  endif

  if (ret_type=2) then  'C -> F
    TC_READ_S=(TC_READ_S*1.8)+32
  endif

endfunction


'---------------------------------------------------------------
''' Reads value of tc iso TYPE T -200 C -> 400 C.
''' module: module address (0..255)
''' channel: (1-8)
''' ret_type: 
'''+       0 = thermovoltage in V
'''+       1 = C
'''+       2 = F
'''-------------------------------------------------------------
function TC_Read_T(module,channel,ret_type) as Float
  dim adr as Long
  dim value as Long
  dim spg as Long
  dim coldjunction as Long
  dim spg2 as Float

  adr = SHIFT_LEFT(module,8) or 0c0h or (channel-1)

  SUB_BEGIN_CRITICAL_SECTION
  poke_nop(ADRD, adr )
  value = peek(d32)
  SUB_END_CRITICAL_SECTION

  coldjunction=(shift_right(value,16)) AND 1FFFH
  if (coldjunction AND 1000H=1000H) then coldjunction=coldjunction or 0FFFFE000H

  spg=VALUE AND 0FFFFH 'thermovoltage 409.6 digit /mV
  if( spg AND 32768=32768) then spg=spg OR 0FFFF0000H
  spg2=spg *2.44140625 'thermovoltage => V
  spg2=spg2 +TC_CONVERT_TYP_T_INV((coldjunction/16))

  IF (ret_type>0) then 'convert
    TC_READ_T=TC_CONVERT_TYP_T(spg2) '-200 C-> 400 C DIN EN 60584-1
  ELSE
    TC_READ_T=spg2
  endif

  if (ret_type=2) then  'C -> F
    TC_READ_T=(TC_READ_T*1.8)+32
  endif

endfunction

'---------------------------------------------------------------
''' Reads value of tc iso TYPE R -50 C -> 1768 C.
''' module: module address (0..255)
''' channel: (1-8)
''' ret_type: 
'''+       0 = thermovoltage in V
'''+       1 = C
'''+       2 = F
'''-------------------------------------------------------------
function TC_Read_R(module,channel,ret_type) as Float
  dim adr as Long
  dim value as Long
  dim spg as Long
  dim coldjunction as Long
  dim spg2 as Float

  adr = SHIFT_LEFT(module,8) or 0c0h or (channel-1)

  SUB_BEGIN_CRITICAL_SECTION
  poke_nop(ADRD, adr )
  value = peek(d32)
  SUB_END_CRITICAL_SECTION

  coldjunction=(shift_right(value,16)) AND 1FFFH
  if (coldjunction AND 1000H=1000H) then coldjunction=coldjunction or 0FFFFE000H

  spg=VALUE AND 0FFFFH 'thermovoltage 409.6 digit /mV
  if( spg AND 32768=32768) then spg=spg OR 0FFFF0000H
  spg2=spg *2.44140625 'thermovoltage => V
  spg2=spg2 +TC_CONVERT_TYP_R_INV((coldjunction/16))

  IF (ret_type>0) then 'convert
    TC_READ_R=TC_CONVERT_TYP_R(spg2)
  ELSE
    TC_READ_R=spg2
  endif

  if (ret_type=2) then  'C -> F
    TC_READ_R=(TC_READ_R*1.8)+32
  endif

endfunction


'---------------------------------------------------------------
''' Reads value of tc iso TYP N  -200C -> 1300 C.
''' module: module address (0..255)
''' channel: (1-8)
''' ret_type: 
'''+        0 = thermovoltage V
'''+        1 = C
'''+        2 = F
'''-------------------------------------------------------------
function TC_Read_N(module,channel,ret_type) as Float
  dim adr as Long
  dim value as Long
  dim spg as Long
  dim coldjunction as Long
  dim spg2 as Float

  adr = SHIFT_LEFT(module,8) or 0c0h or (channel-1)

  SUB_BEGIN_CRITICAL_SECTION
  poke_nop(ADRD, adr )
  value = peek(d32)
  SUB_END_CRITICAL_SECTION

  coldjunction=(shift_right(value,16)) AND 1FFFH
  if (coldjunction AND 1000H=1000H) then coldjunction=coldjunction or 0FFFFE000H

  spg=VALUE AND 0FFFFH 'thermovoltage 409.6 digit /mV
  if( spg AND 32768=32768) then spg=spg OR 0FFFF0000H

  spg2=spg *2.44140625 'thermovoltage => V
  spg2=spg2 +TC_CONVERT_TYP_N_INV((coldjunction/16))

  IF (ret_type>0) then 'convert
    TC_READ_N=TC_CONVERT_TYP_N(spg2) '-210 C->1200 C DIN EN 60584-1
  ELSE
    TC_READ_N=spg2
  endif

  if (ret_type=2) then  'C -> F
    TC_READ_N=(TC_READ_N*1.8)+32
  endif

endfunction

'---------------------------------------------------------------
''' Reads value of tc iso TYPE E -200 C -> 1000 C.
''' module: module address (0..255)
''' channel: (1-8)
'''ret_type:
'''+          0 = thermovoltage in V
'''+          1 = C
'''+          2 = F
'''-------------------------------------------------------------
function TC_Read_E(module,channel,ret_type) as Float
  dim adr as Long
  dim value as Long
  dim spg as Long
  dim coldjunction as Long
  dim spg2 as Float

  adr = SHIFT_LEFT(module,8) or 0c0h or (channel-1)

  SUB_BEGIN_CRITICAL_SECTION
  poke_nop(ADRD, adr )
  value = peek(d32)
  SUB_END_CRITICAL_SECTION

  coldjunction=(shift_right(value,16)) AND 1FFFH
  if (coldjunction AND 1000H=1000H) then coldjunction=coldjunction or 0FFFFE000H

  spg=VALUE AND 0FFFFH 'thermovoltage 409.6 digit /mV
  if( spg AND 32768=32768) then spg=spg OR 0FFFF0000H
  spg2=spg *2.44140625 'thermovoltage => V
  spg2=spg2 +TC_CONVERT_TYP_E_INV((coldjunction/16))

  IF (ret_type>0) then 'convert
    TC_READ_E=TC_CONVERT_TYP_E(spg2)
  ELSE
    TC_READ_E=spg2
  endif

  if (ret_type=2) then  'C -> F
    TC_READ_E=(TC_READ_E*1.8)+32
  endif

endfunction

'---------------------------------------------------------------
''' Reads value of tc iso TYPE B '250 C - 1820 C.
''' module: module address (0..255)
''' channel: (1-8)
''' ret_type:
'''+       0 = thermovoltage in V
'''+       1 = C
'''+       2 = F
'''-------------------------------------------------------------
function TC_Read_B(module,channel,ret_type) as Float
  dim adr as Long
  dim value as Long
  dim spg as Long
  dim coldjunction as Long
  dim spg2 as Float

  adr = SHIFT_LEFT(module,8) or 0c0h or (channel-1)
  SUB_BEGIN_CRITICAL_SECTION
  poke_nop(ADRD, adr )
  value = peek(d32)
  SUB_END_CRITICAL_SECTION

  spg=VALUE AND 0FFFFH 'thermovoltage 409.6 digit /mV
  if( spg AND 32768=32768) then spg=spg OR 0FFFF0000H
  spg2=spg *2.44140625 'thermovoltage => V


  IF (ret_type>0) then 'convert
    TC_READ_B=TC_CONVERT_TYP_B(spg2)
  ELSE
    TC_READ_B=spg2
  endif

  if (ret_type=2) then  'C -> F
    TC_READ_B=(TC_READ_B*1.8)+32
  endif
endfunction



'---------------------------------------------------------------
''' Sets the samplerate of tc iso module.
''' module: dip switch address (0..255)
''' rate:
'''+      1 samplerate = 3520 Hz
'''+      2 samplerate = 1760 Hz
'''+      3 samplerate = 880 Hz
'''+      4 samplerate = 440 Hz
'''+      5 samplerate = 220 Hz
'''+      6 samplerate = 110 Hz
'''+      7 samplerate = 55 Hz
'''+      8 samplerate = 27.5 Hz
'''+      9 samplerate = 13.75 Hz
'''+     15 samplerate = 6.875 Hz (default)
'''-------------------------------------------------------------
sub TC_Set_Rate(module,rate)
  dim adr as Long
  adr = SHIFT_LEFT(module,8)or 0c0h

  SUB_BEGIN_CRITICAL_SECTION
  poke(ADWR,adr)
  nop_t9
  poke_nop(d32,rate)
  SUB_END_CRITICAL_SECTION
endsub


'---------------------------------------------------------------
''' Reads the input voltage [v] without coldjunction correction
'''+ This function may be used if not a Thermocouple is connected
'''+ to the inputs of the TC-8 ISO ,but if a voltage is applied
'''+ directly to the inputs. Max. input voltage is  + - 80 mVolt
''' module: module address (0..255)
''' channel: (1-8)
'''-------------------------------------------------------------
function TC_Read_Voltage(module,channel) as Float
  dim adr as Long
  dim value as Long
  dim spg as Long

  adr = SHIFT_LEFT(module,8) or 0c0h or (channel-1)

  SUB_BEGIN_CRITICAL_SECTION
  poke_nop(ADRD, adr )
  value = peek(d32) AND 0FFFFH
  SUB_END_CRITICAL_SECTION

  if( VALUE AND 32768=32768) then value=value OR 0FFFF0000H

  TC_READ_VOLTAGE=VALUE *2.44140625 'voltage => V

endfunction
'<ENDREGION>

'<REGION> LS-Bus
'-------------------LS-BUS

''' Resets the watchdog timer, sets digital outputs and
'''+ reads digital inputs.
'''+ return: state of digital outputs and inputs
''' module: module address (0..255)
''' channel: number of the LS interface on the LS module
'''+ ls_module: device nr lsbus (FIX 1)
'''value: each bit corresponds to a channel
'''-------------------------------------------------------------
function LS_Dig_IO(module, channel, value) as Long
#If MAKE_LIB = OFF Then
  Dim ld[4] As Long At DM_Local
#else
  Dim ld[4] As Long
#endif
  
  dim cnt_i as Long
  dim adr as Long

  adr=(shift_left(module,8) or ext) + (channel-1)*8
  for cnt_i=1 to 4                          ' rx data read
    SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr)
    ld[cnt_i] = peek(d32)
    SUB_END_CRITICAL_SECTION
  next cnt_i

  LS_DIG_IO = ld[1] or (shift_left(ld[2],8)) or (shift_left(ld[3],16)) or (shift_left(ld[4],24))

  ld[1] = 1                                 ' WD trigger
  I_SEND_BC(module,channel,44h, 1, ld)

  ld[1] = value and 0FFh                    ' tx data transmit
  ld[2] = shift_right(value,8) and 0FFh
  ld[3] = shift_right(value,16) and 0FFh
  ld[4] = shift_right(value,24) and 0FFh
  I_SEND_NA(module,channel,1, 7Ch, 4, ld)     ' channel 1..32

  LS_READ_REQ(module,channel,1, 7Ch, 4)       ' request new in data
endfunction


'---------------------------------------------------------------
''' Enables, disables and configures the watchdog
'''+ return: error code (0->ok)
''' module: module address (0..255)
''' channel: number of the LS interface on the LS module
''' ls_module: device nr lsbus (1..15)
''' enable:  
'''+           0->disable
'''+           1->enable
''' time: trigger time [ms]
'''---------------------------------------------------------------
function LS_Watchdog_Init(module, channel, ls_module, enable, time) as Long

  
#If MAKE_LIB = OFF Then
  Dim ld[4] As Long At DM_Local
#else
  Dim ld[4] As Long
#endif
  
  
  dim ret, t as Long

  'Watchdog disable
  ld[1] = 0ADh
  ld[2] = 0
  ret = I_SEND(module,channel,ls_module, 45h, 2, ld)

  'Watchdog time
  t = time / 25e-6
  ld[1] = t and 0FFh
  ld[2] = shift_right(t,8) and 0FFh
  ld[3] = shift_right(t,16) and 0FFh
  ld[4] = shift_right(t,24) and 0FFh
  ret = ret or (I_SEND(module,channel,ls_module, 48h, 4, ld))

  ' Watchdog enable
  ld[1] = 0ADh
  ld[2] = enable and 1
  LS_WATCHDOG_INIT = ret or (I_SEND(module,channel,ls_module, 45h, 2, ld))
endfunction


'---------------------------------------------------------------
''' Resets the watchdog timer.
'''+ If the watchdog is activated,the user program has to call
'''+ this Function at least every ....
''' module: module address (0..255)
''' channel: number of the LS interface on the LS module
'''-------------------------------------------------------------
sub LS_Watchdog_Reset(module, channel)
#If MAKE_LIB = OFF Then
  Dim ld[1] As Long At DM_Local
#else
  Dim ld[1] As Long
#endif
  ld[1] = 1
  I_SEND_BC(module,channel,44h, 1, ld)
endsub


'---------------------------------------------------------------
''' Initialises a digital I/O module (channel 0-31)
'''+ return: error code (0->ok)
''' module: module address (0..255)
''' channel: number of the LS interface on the LS module
''' ls_module: device nr LS-bus (1..15)
''' value:     each bit corresponds to 8 channel
'''+           0 -> input
'''+           1 -> output
'''+           bit 0: channels 1..8
'''+               1: channels 9..16
'''+               2: channels 17..24
'''+               3: channels 25..32
'''-------------------------------------------------------------
function LS_DigProg(module, channel, ls_module, value) as Long
#If MAKE_LIB = OFF Then
  Dim ld[2] As Long At DM_Local
#else
  Dim ld[2] As Long
#endif
  
  
  dim ret as Long

  ld[1] = shift_left(value,3) and 8h
  ld[1] = ld[1] or (shift_left(value,7) and 80h)
  ld[1] = ld[1] or 11h                     ' as after reset
  ld[2] = shift_left(value,2) and 8h
  ld[2] = ld[2] or (shift_left(value,6) and 80h)
  ld[2] = ld[2] or 11h
  ret = I_SEND(module,channel,ls_module, 16h, 2, ld)

  ld[1] = shift_left(value,1) and 8h
  ld[1] = ld[1] or (shift_left(value,5) and 80h)
  ld[1] = ld[1] or 11h
  ld[2] = value and 8h
  ld[2] = ld[2] or (shift_left(value,4) and 80h)
  ld[2] = ld[2] or 11h
  LS_DIGPROG = ret or (I_SEND(module,channel,ls_module, 20h+16h, 2, ld))
endfunction


'---------------------------------------------------------------
''' Sets the digital outputs (channel 0 - 31).
''' module: module address (0..255)
''' channel: number of the LS interface on the LS module
''' ls_module: device nr LS-bus (1..15)
''' value: each bit corresponds to a channel
'''---------------------------------------------------------------
sub LS_Digout_Long(module, channel, ls_module, value)
#If MAKE_LIB = OFF Then
  Dim ld[4] As Long At DM_Local
#else
  Dim ld[4] As Long
#endif
  ld[1] = value and 0FFh
  ld[2] = shift_right(value,8) and 0FFh
  ld[3] = shift_right(value,16) and 0FFh
  ld[4] = shift_right(value,24) and 0FFh
  I_SEND_NA(module,channel,ls_module, 7Ch, 4, ld) ' channel 1..32
endsub


'---------------------------------------------------------------
''' Sets the digital outputs and read error code (channel 0 - 31).
''' module: module address (0..255)
''' channel: number of the LS interface on the LS module
''' ls_module: device nr LS-bus (1..15)
''' value: each bit corresponds to a channel
''' BUS_stat: Error Code 0=OK 
'''---------------------------------------------------------------
Sub LS_Digout_Long_BS(module, channel, ls_module, value, BUS_stat)
#If MAKE_LIB = OFF Then
  Dim ld[4] As Long At DM_Local
#else
  Dim ld[4] As Long
#endif
  
  
  ld[1] = value And 0FFh
  ld[2] = Shift_Right(value, 8) And 0FFh
  ld[3] = Shift_Right(value, 16) And 0FFh
  ld[4] = Shift_Right(value, 24) And 0FFh
  BUS_stat=I_Send(module, channel, ls_module, 7Ch, 4, ld) ' channel 1..32
EndSub

'---------------------------------------------------------------
''' Reads the digital inputs (channel 0 - 31).
'''+Return: state of digital outputs and inputs
''' module: module address (0..255)
''' channel: number of the LS interface on the LS module
''' ls_module: device nr LS-bus (1..15)
'''-------------------------------------------------------------
function LS_Digin_Long(module, channel, ls_module) as Long
#If MAKE_LIB = OFF Then
  Dim ld[4] As Long At DM_Local
#else
  Dim ld[4] As Long
#endif
  
  dim ret as Long

  ret = I_RECEIVE(module,channel,ls_module, 7Ch, 4, ld)
  LS_DIGIN_Long = ld[1] or (shift_left(ld[2],8)) or (shift_left(ld[3],16)) or (shift_left(ld[4],24))
endfunction

'---------------------------------------------------------------
''' Reads the digital inputs (channel 0 - 31).
'''+Return: state of digital outputs and inputs
''' module: module address (0..255)
''' channel: number of the LS interface on the LS module
''' ls_module: device nr LS-bus (1..15)
''' BUS_stat: Error Code 0=OK 
'''-------------------------------------------------------------
Function LS_Digin_Long_BS(module, channel, ls_module, BUS_stat) As Long
#If MAKE_LIB = OFF Then
  Dim ld[4] As Long At DM_Local
#else
  Dim ld[4] As Long
#endif
  
  
  Dim ret As Long
  BUS_stat = I_Receive(module, channel, ls_module, 7Ch, 4, ld)
  LS_Digin_Long_BS = ld[1] Or (Shift_Left(ld[2], 8)) Or (Shift_Left(ld[3], 16)) Or (Shift_Left(ld[4], 24))
EndFunction

'---------------------------------------------------------------
''' Reads the digital output status (overcurrent) (channel 0 - 31).
'''+Return: each bit corresponds a channel 0 = OK 1 = Error
''' module: module address (0..255)
''' channel: number of the LS interface on the LS module
''' ls_mod_adr: device nr lsbus
'''-------------------------------------------------------------
function LS_Get_Output_Status(module, channel, ls_mod_adr) as Long
#If MAKE_LIB = OFF Then
  Dim ld[4] As Long At DM_Local
#else
  Dim ld[4] As Long
#endif
  
  
  dim ret,t as Long

  t = I_RECEIVE(module,channel,ls_mod_adr, 50h, 4, ld)
  ret=ld[1] or shift_left(ld[2],8) or shift_left(ld[3],16) or shift_left(ld[4],24)
  LS_GET_OUTPUT_STATUS = ret
endfunction


'---------------------------------------------------------------
''' Initialises the LS-Module.
'''+Return: error code (0->ok)
''' module: module address (0..255)
''' channel: number of the LS interface on the LS module
''' ls_module: device nr LS-bus (1..15)
'''-------------------------------------------------------------
function LS_DIO_Init(module, channel, ls_module) as Long
#If MAKE_LIB = OFF Then
  Dim ld[4] As Long At DM_Local
#else
  Dim ld[4] As Long
#endif
  
  
  dim ret as Long
  dim adr as Long

  adr=(shift_left(module,8) or ext) + (channel-1)*8
  SUB_BEGIN_CRITICAL_SECTION
  poke(ADWR, adr+6)                       ' autoreset rx ON
  nop_t9
  poke_nop(d32, 1)
  SUB_END_CRITICAL_SECTION

  ld[1] = 3
  ret = I_SEND(module,channel,ls_module, 40h, 1, ld)            ' Reset JX 1,2
  ld[1] = 1
  ret = ret or (I_SEND(module,channel,ls_module, 5Ch, 1, ld))   ' timeout reset

  ld[1] = 4
  ret = ret or (I_SEND(module,channel,ls_module, 4Ch, 1, ld))   ' Set default direction time

  ld[1]=0
  ld[2]=0
  ld[3]=0
  ld[4]=0
  LS_DIO_INIT = ret or (I_SEND(module,channel,ls_module, 50h, 4, ld)) ' overcurrent reset

  ld[1]=30h
  LS_DIO_INIT = ret or (I_SEND(module,channel,ls_module, 43h, 1, ld)) ' overtemperature reset
endfunction
'<ENDREGION>


#ELSE ' not ADSP, not T11
'<REGION> Declaration
dim test as Long   ''<HIDE>               ' variable for delay
dim CAN_msg[9] as Long                    ' array with 9 elements
' element 1 to 8 for databyte 1 to 8 in CAN-Frame
' element 9 for the number of databytes in CAN-Frame

'***************************************************************
' Address-table to access the hardware of the Pro-system,
' depending on the CPU in use (ADSP OR Transputer).
'***************************************************************
#IF PROZESSOR = T9 THEN
#define DL         20400000H ''<HIDE> 
#define DH         20400010H ''<HIDE> 
#define DLX        20400020H ''<HIDE> 
#define DHX        20400030H ''<HIDE> 
#define ADWR       20400060H ''<HIDE> 
#define ADRD       20400070H ''<HIDE> 
#define cpu_EVENT  204000F0H ''<HIDE> 
#define watchdog   204001D0H ''<HIDE> 
#define WD_TIMER   204001E0H ''<HIDE> 
#define cpu_LED    204001F0H ''<HIDE> 
#ELSE
#define DL               00H ''<HIDE> 
#define DH               10H ''<HIDE> 
#define DLX              20H ''<HIDE> 
#define DHX              30H ''<HIDE> 
#define ADWR             60H ''<HIDE> 
#define ADRD             70H ''<HIDE> 
#define cpu_EVENT       0F0H ''<HIDE> 
#define watchdog        1D0H ''<HIDE> 
#define WD_TIMER        1E0H ''<HIDE> 
#define cpu_LED         1F0H ''<HIDE> 
#ENDIF

'Profibus slave adresses (DPRAM)
'Handshakeregisters
#define app_ind     7feH ''<HIDE> 
#define any_ind     7ffH ''<HIDE> 
'Mailboxregisters
#define mail_in_0     400H ''<HIDE> 
#define mail_in_1     401H ''<HIDE> 
#define mail_in_2     402H ''<HIDE> 
#define mail_in_3     403H ''<HIDE> 
#define mail_in_4     404H ''<HIDE> 
#define mail_in_5     405H ''<HIDE> 
#define mail_in_6     406H ''<HIDE> 
#define mail_in_7     407H ''<HIDE> 
#define mail_in_8     408H ''<HIDE> 
#define mail_in_9     409H ''<HIDE> 
#define mail_in_a     40aH ''<HIDE> 
#define mail_in_b     40bH ''<HIDE> 
#define mail_in_c     40cH ''<HIDE> 
#define mail_in_d     40dH ''<HIDE> 
#define mail_in_e     40eH ''<HIDE> 
#define mail_in_f     40fH ''<HIDE> 

#define mail_out_0      520H ''<HIDE> 
#define mail_out_1      521H ''<HIDE> 
#define mail_out_2      522H ''<HIDE> 
#define mail_out_3      523H ''<HIDE> 
#define mail_out_4      524H ''<HIDE> 
#define mail_out_5      525H ''<HIDE> 
#define mail_out_6      526H ''<HIDE> 
#define mail_out_7      527H ''<HIDE> 
#define mail_out_8      528H ''<HIDE> 
#define mail_out_9      529H ''<HIDE> 
#define mail_out_a      52aH ''<HIDE> 
#define mail_out_b      52bH ''<HIDE> 
#define mail_out_c      52cH ''<HIDE> 
#define mail_out_d      52dH ''<HIDE> 
#define mail_out_e      52eH ''<HIDE> 
#define mail_out_f      52fH ''<HIDE> 
'<ENDREGION>

'<REGION> Helper function

'*****************************************************************
' Inserts 4 nop's after a poke instruction if the used processor
' is an ADSP.
'*****************************************************************
sub poke_nop(address,value) ''<HIDE>
#IF PROZESSOR = T9 THEN
  poke(address,value)
  nop
  nop
  nop
  nop
  nop   ' 5 th NOP
#ELSE
  poke(address,value)
#ENDIF
endsub

'*****************************************************************
' Inserts 1 nop if the used processor is an ADSP.
'*****************************************************************
sub nop_t9() ''<HIDE>
#IF PROZESSOR = T9 THEN
  nop
#ENDIF
endsub
'<ENDREGION>

'<REGION> Thermocouple
'-----------------Thermocouple

'***********************************************
' Sets the thermocouple multipexer.
' module: module address (0..255)
' channel: multiplexer channel
'***********************************************
SUB TC_Select(module,channel)
  DIM adr,adcnr as Long

  PRECALC
  adr = 0D0H OR (SHIFT_LEFT(module,8))
#IF PROZESSOR = T9 THEN           'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
#IF PRIORITAET = LOW
  BEGIN_CRITICAL_SECTION
#ENDIF
#ENDIF
  poke (ADWR, adr)
  nop_t9
  poke_nop (DLX, channel-1)
#IF PROZESSOR = T9 THEN           'This part enables the interrupt.
#IF PRIORITAET = LOW
  END_CRITICAL_SECTION
#ENDIF
#ENDIF
ENDSUB
'<ENDREGION>

'<REGION> RSxxx
'-------------------serial interface

'***********************************************
' Sets a register of the serial controller.
' module: module address (0..255)
' register_no: register on the serial controller
' value: value for the selected register
'***********************************************
sub Set_RS(module,register_no,value)
  dim adr as Long
  adr = (0c0h + register_no) or (shift_left(module, 8))
#IF PROZESSOR = T9 THEN           'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
#IF PRIORITAET = LOW
  BEGIN_CRITICAL_SECTION
#ENDIF
#ENDIF
  poke (adwr, adr)
  nop_t9
  poke_nop (dlx, value)
#IF PROZESSOR = T9 THEN           'This part enables the interrupt.
#IF PRIORITAET = LOW
  END_CRITICAL_SECTION
#ENDIF
#ENDIF
endsub

'***********************************************
' Reads the value of a register of the serial controller.
' module: module address (0..255)
' regno: register on the serial controller
'**********************************************
FUNCTION Get_RS(module, register_no) AS Long
  DIM adr as Long
  adr = (0c0h + register_no) or (shift_left(module,8))
#IF PROZESSOR = T9 THEN           'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
#IF PRIORITAET = LOW
  BEGIN_CRITICAL_SECTION
#ENDIF
#ENDIF
  poke_nop(adrd, adr)
  get_rs = peek(DLX)
#IF PROZESSOR = T9 THEN           'This part enables the interrupt.
#IF PRIORITAET = LOW
  END_CRITICAL_SECTION
#ENDIF
#ENDIF
ENDFUNCTION

'******************************************************************
' Initialises a serial interface.
'List of parameters:
'module: module address (0..255)
'channel: number of the serial interface (one ADwin-PRO module contains 2 or 4 interfaces)
'Baud: Baudrate for the serial comunication
'parity :     0 = no parity
'             1 = even
'             2 = odd
'bits: Number of databits for the serial comunication
'stop     :   0 = 1 Stopbit
'             1 = 1,5 Stopbits by using 5 Databits
'             1 = 2 Stopbits bei 6,7 by using 8 Databits
'handshake:   0 = RS-232 no handshake
'             1 = RS-232 Hardware handshake (RTS/CTS)
'             2 = RS-232 Software handshake (Xon/Xoff)
'             3 = RS-485 no handshake
'******************************************************************

sub RS_Init(module,channel,baud,parity,bits,stop,handshake)
  dim hard_adr as Long               ' phyisical address of the ADwin module (basic address)
  dim offset as Long                             ' offset for the selected serial interface
  dim divisor as Long               ' value by which the external clock has to be divided to get the selected baudrate
  dim DLL_value as Long              ' value for the DLL register
  dim DLH_value as Long              ' value for the DLH register
  dim LCR_value as Long                          ' value for the LCR register

  offset = ((channel - 1) and 1) * 8

  if (channel >= 3) then                ' for ADwin-PRO modules with more the 2 serial interfaces
    hard_adr = module + 1                 ' The hardware address for the serial interfaces 3 and 4 is dip switch + 1
  else
    hard_adr = module                                 ' The hardware address for the serial interfaces 3 and 4 is dip switch
  endif

  divisor = (36864000/1) / (baud*16)         ' calculates the the divider for the external clock
  DLL_value = divisor and 0ffh              ' value for the DLL register
  DLH_value = shift_right((divisor and 0ff00h),8)       ' value for the DLH register

  LCR_value = bits - 5
  LCR_value = LCR_value or shift_left(stop,2)
  if (parity = 1) then LCR_value = LCR_value or 011000b
  if (parity = 2) then LCR_value = LCR_value or 001000b     'value for the LCR register


  set_rs(hard_adr, offset + 3, 080h)      ' LCR-bit7=1  Divisor latch enable
  set_rs(hard_adr, offset + 0, DLL_value)     ' DLL-reg   setting baudrate
  set_rs(hard_adr, offset + 1, DLH_value)     ' DLH-reg   setting baudrate
  set_rs(hard_adr, offset + 3,  (0bfh))       ' LCR-reg   Enhanced feature reg enable
  set_rs(hard_adr, offset + 4,  011h)         ' setting character for softwarehandshake Xon1
  set_rs(hard_adr, offset + 5,  012h)         ' setting character for softwarehandshake Xon2
  set_rs(hard_adr, offset + 6,  013h)         ' setting character for softwarehandshake Xoff1
  set_rs(hard_adr, offset + 7,  014h)         ' setting character for softwarehandshake Xoff2
  if (handshake = 0) then
    set_rs(hard_adr, offset + 2, 010h)      ' EFR-reg   no handshake(RS232) + enhanced functions enabeld
  endif
  if (handshake = 1) then
    set_rs(hard_adr, offset + 2, 0d0h)      ' EFR-reg   hardwarehandshake(RS232) + enhanced functions enabeld
  endif
  if (handshake = 2) then
    set_rs(hard_adr, offset + 2, 01ah)      ' EFR-reg   softwarehandshake(RS232) (Xon1/Xoff1) + enhanced functions enabeld
  endif
  if (handshake = 3) then
    set_rs(hard_adr, offset + 2, 090h)      ' EFR-reg   no handshake (RS485) + enhanced functions enabeld
  endif
  set_rs(hard_adr, offset + 3,  LCR_value)    ' LCR-reg   Divisor latch disable; 8 Databits
  set_rs(hard_adr, offset + 4 , 040h)       ' MCR reg   enable access to TCR and TLR register
  set_rs(hard_adr, offset + 6 , 087h)       ' TCR reg   FIFO trigger level
  set_rs(hard_adr, offset + 4 , 04h)      ' MCR reg   FIFOrdy reg enable; is necessary to get status information of the FIFO
  set_rs(hard_adr, offset + 2, 00fh)      ' FCR-reg   FIFOs enable, FIFOs clear, DMA Mode1
endsub


'***************************************************************
' Resets the serial interface module.
' module: module address (0..255)
'***************************************************************
sub RS_Reset(module)
  set_rs(module, 23, 1)           ' reset aktiv
  set_rs(module, 23, 0)           ' reset not aktiv
endsub



'***************************************************************
' Writes a byte to the transmit FIFO, if the FIFO is not full.
' module: module address (0..255)
' channel: number of the serial interface (one ADwin-PRO module contains 2 or 4 interfaces)
' value: value which should be written to the FIFO
' return value:
' write_fifo : 0 = byte is written
'             1 = FIFO full
'***************************************************************

function Write_FIFO(module,channel,value) as Long
  dim hard_adr as Long       ' phyisical address of the ADwin module (basic address)
  dim offset as Long       ' offset for the selected serial interface
  dim bit as Long
  dim fifo_free as Long      ' FIFO status
  if (channel = 1) then bit = 01h   ' select the bit, which indicates the status of the selected FIFO
  if (channel = 2) then bit = 08h
  if (channel = 3) then bit = 02h
  if (channel = 4) then bit = 04h
  fifo_free = get_rs(module, 7) and bit
  if (fifo_free  <> 0) then       ' If the FIFO is not full then the byte is written
    offset = ((channel - 1) and 1) * 8
    if (channel >= 3) then
      hard_adr = module + 1
    else
      hard_adr = module
    endif
    set_rs(hard_adr,offset, value)      ' Writeing byte to transmit FIFO
    write_fifo = 0              ' return value: byte is written successful to the transmit FIFO
  else
    write_fifo = 1        ' return value: Fifo full; byte is not written
  endif
endfunction


'***************************************************************
' Checks if there is any more data to transmit.
' module: module address (0..255)
' channel: number of the serial interface (one ADwin-PRO module contains 2 or 4 interfaces)
' return value:
' check_shift_reg : 0 = Shift register and transmit hold are empty
'              1 = Shift register and transmit hold are not empty
'***************************************************************

function Check_Shift_Reg(module,channel) as Long
  dim hard_adr as Long       ' phyisical address of the ADwin module (basic address)
  dim offset as Long       ' offset for the selected serial interface
  dim ret as Long        ' return value
  offset = ((channel - 1) and 1) * 8
  if (channel >= 3) then
    hard_adr = module + 1
  else
    hard_adr = module
  endif
  ret = get_rs(hard_adr,offset + 5) and 64  ' reading the status byte
  if (ret = 64) then
    check_shift_reg = 0
  else
    check_shift_reg = 1
  endif
endfunction


'***************************************************************
' Reads byte from the receive FIFO.
' module: module address (0..255)
' channel: number of the serial interface (one ADwin-PRO module contains 2 or 4 interfaces)
' return value:
' read_fifo : 0 - 255 = value of the received byte
'            -1 = no bytes in the receive FIFO
'***************************************************************

function Read_FIFO(module,channel) as Long
  dim hard_adr as Long       ' phyisical address of the ADwin module (basic address)
  dim bit as Long
  dim offset as Long       ' offset for the selected serial interface
  dim fifo_status as Long      ' FIFO status
  offset = ((channel - 1) and 1) * 8
  if (channel >= 3) then
    hard_adr = module + 1
  else
    hard_adr = module
  endif
  fifo_status = get_rs(hard_adr,offset + 5) and 1
  if (fifo_status <> 0) then      ' read byte, if there is a byte in the receive FIFO
    read_fifo = get_rs(hard_adr,offset) ' read byte from receive FIFO (return value = value of the received byte)
  else
    read_fifo = -1        ' no new byte in the receive FIFO (return value = -1)
  endif
endfunction

'***************************************************************
' Only for RS485.
' Selects whether the interface is sending data or is listening on the bus.
' module: module address (0..255)
' channel: number of the serial interface (one ADwin-PRO module contains 2 or 4 interfaces)
' dir:  0 = Listening
'           1 = Sending Data
'           2 = Sending Data + Listening
'***************************************************************

sub RS485_Send(module,channel,dir)
  dim hard_adr as Long       ' physical address of the ADwin module (basic address)
  dim offset as Long       ' offset for the selected serial interface
  dim reg_value as Long
  if (dir = 0) then reg_value = 5
  if (dir = 1) then reg_value = 6
  if (dir = 2) then reg_value = 7
  offset = ((channel - 1) and 1) * 8
  if (channel >= 3) then
    hard_adr = module + 1
  else
    hard_adr = module
  endif
  set_rs(hard_adr,offset + 4,reg_value) 'setting the RTS-Pin
endsub
'<ENDREGION>

'<REGION> CAN
'------------------CAN

'***************************************************************
' Enables a message object for receiving messages.
' Disables all interrups of the message object.
' module: module address (0..255)
' channel: number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
' msg_no: Number of the message object
' Identifier: incomming frames are accepted by this message object, if the identifier matches the frame identifier
' extended: Determines whether the identifier is 11 or 29 Bit
'      0 = 11 Bit Identifier
'      1 = 29 Bit Identifier
'***************************************************************

sub En_Receive(module,channel,msg_no,identifier,extended)
  set_can_reg(module,channel, msg_no * 16, 149)             'enable message object
  if (extended = 0) then
    set_can_reg(module,channel, msg_no * 16 + 6, 128)           'read; DLC = 8 ; 11 Bit Identifier
    set_can_reg(module,channel, msg_no * 16 + 2, (shift_right(identifier,3)and 255))  'Set Identifier
    set_can_reg(module,channel, msg_no * 16 + 3, (shift_left(identifier,5)and 255))
  else
    set_can_reg(module,channel, msg_no * 16 + 6, 132)           'read; DLC = 8 ; 29 Bit Identifier
    set_can_reg(module,channel, msg_no * 16 + 2, (shift_right(identifier,21)and 255)) 'Set Identifier
    set_can_reg(module,channel, msg_no * 16 + 3, (shift_right(identifier,13)and 255))
    set_can_reg(module,channel, msg_no * 16 + 4, (shift_right(identifier,5)and 255))
    set_can_reg(module,channel, msg_no * 16 + 5, (shift_left(identifier,3)and 255))
  endif
endsub


'***************************************************************
' Enables a message object for transmitting messages.
' Disables all interrups of the message object.
' module: module address (0..255)
' channel: number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
' msg_no: Number of the message object
' Identifier: identifier for the frames which will be transmitted
' extended: Determines whether the identifier is 11 or 29 Bit
'      0 = 11 Bit Identifier
'      1 = 29 Bit Identifier
'***************************************************************

sub En_Transmit(module,channel,msg_no,identifier,extended)
  set_can_reg(module,channel, msg_no * 16, 149)             'enable message object
  if (extended = 0) then
    set_can_reg(module,channel, msg_no * 16 + 6, 136)           'write; DLC = 8 ; 11 Bit Identifier
    set_can_reg(module,channel, msg_no * 16 + 2, (shift_right(identifier,3)and 255))  'Set Identifier
    set_can_reg(module,channel, msg_no * 16 + 3, (shift_left(identifier,5)and 255))
  else
    set_can_reg(module,channel, msg_no * 16 + 6, 140)           'write; DLC = 8 ; 29 Bit Identifier
    set_can_reg(module,channel, msg_no * 16 + 2, (shift_right(identifier,21)and 255)) 'Set Identifier
    set_can_reg(module,channel, msg_no * 16 + 3, (shift_right(identifier,13)and 255))
    set_can_reg(module,channel, msg_no * 16 + 4, (shift_right(identifier,5)and 255))
    set_can_reg(module,channel, msg_no * 16 + 5, (shift_left(identifier,3)and 255))
  endif
endsub



'***************************************************************
' Initialises the CAN-controller.
' All message objects will be disabled.
' Bitrate: 1MBit/s
' Acceptance filter : Must match
' module: module address (0..255)
' channel: number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
'***************************************************************

sub Init_CAN(module,channel)
  dim counter as Long
  dim adr1 as Long

  adr1 = 0c0h or (shift_left(module, 8)) or (38 + channel)

#IF PROZESSOR = T9 THEN           'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
#IF PRIORITAET = LOW
  BEGIN_CRITICAL_SECTION
#ENDIF
#ENDIF
  poke(adwr, adr1)           ' Reset the CAN-Controllers (Hardwarereset)
  nop_t9
  poke_nop(dlx, 1)
#IF PROZESSOR = T9 THEN           'This part enables the interrupt.
#IF PRIORITAET = LOW
  END_CRITICAL_SECTION
#ENDIF
#ENDIF
#IF PROZESSOR = T9 THEN           'Resetpin must be low for at least 1 ms
  sleep(10000)
#ELSE
  nwtime=read_timer()
  wait(1000)
#ENDIF
#IF PROZESSOR = T9 THEN           'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
#IF PRIORITAET = LOW
  BEGIN_CRITICAL_SECTION
#ENDIF
#ENDIF
  poke(adwr, adr1)
  nop_t9
  poke_nop(dlx, 0)
#IF PROZESSOR = T9 THEN           'This part disables the interrupt.
#IF PRIORITAET = LOW
  END_CRITICAL_SECTION
#ENDIF
#ENDIF

  set_can_reg(module,channel, 0,65)         'Access to the registers of the controller only for CPU

  set_can_reg(module,channel, 2,65)         'CPU interface register

  set_can_reg(module,channel, 06h,0ffh)       'Setting all masks to "must match"
  set_can_reg(module,channel, 07h,0ffh)
  set_can_reg(module,channel, 08h,0ffh)
  set_can_reg(module,channel, 09h,0ffh)
  set_can_reg(module,channel, 0ah,0ffh)
  set_can_reg(module,channel, 0bh,0ffh)
  set_can_reg(module,channel, 0ch,0ffh)
  set_can_reg(module,channel, 0dh,0ffh)
  set_can_reg(module,channel, 0eh,0ffh)
  set_can_reg(module,channel, 0fh,0ffh)

  set_can_reg(module,channel, 01fh,0)       ' Clock Out Register

  set_can_reg(module,channel, 02fh,0)       '  Bus configuration register

  set_can_reg(module,channel, 03fh,0)       ' Bit Timing register 0

  set_can_reg(module,channel, 04fh,032h)        ' Bit Timing register 1


  for counter = 1 to 15         'Disable all message objects
    set_can_reg(module,channel, counter * 16,85)
    set_can_reg(module,channel, counter * 16 + 1,85)
  next counter

  set_can_reg(module,channel, 0,0)        'Access to the registers of the controller only for Application
endsub




'***************************************************************
' Checks if there is a new frame in the selected
'message object. If there is a new frame all databytes are read
'and then written to the array "can_msg".
'The number of dadabytes is written to the element 9 of the array "can_msg".
'The return value of the function is the identifier of the frame.
'If there is no new frame in the message box the return value is -1.
'module: module address (0..255)
'channel: number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
'msg_no: number of the message object
'***************************************************************

function Read_Msg(module,channel,msg_no) as Long
  dim new as Long                                           ' new message in the message object
  dim id0,id1,id2,id3 as Long                               ' Identifier Byte 0 and 1
  dim counter as Long
  dim buffer as Long
  dim id_lenght as Long               ' buffer to distinguish 11 and 29 bit identifier

  new = get_can_reg(module,channel, msg_no * 16 + 1) and 3           ' Check, if a new frame in arrived
  if (new =2) then                                               ' New frame is arrived
    buffer = (get_can_reg(module,channel, msg_no * 16 + 6))
    can_msg[9] = shift_right((buffer and 0f0h),4)               ' Number of databytes
    id_lenght = buffer and 4

    id0 = get_can_reg(module,channel, msg_no * 16 + 2)    ' Identifier registers
    id1 = get_can_reg(module,channel, msg_no * 16 + 3)
    if (id_lenght = 4) then
      id2 = get_can_reg(module,channel, msg_no * 16 + 4)
      id3 = get_can_reg(module,channel, msg_no * 16 + 5)
    endif

    for counter = 1 to can_msg[9]         ' reading databytes
      can_msg[counter] = get_can_reg(module,channel, (msg_no * 16) +counter+6)
    next counter

    set_can_reg(module,channel, msg_no * 16 , 0fdh)         ' Reset the new data flag
    set_can_reg(module,channel, msg_no * 16 +1 , 85)
    if (id_lenght = 0) then
      read_msg = (shift_right(id1,5)) or (shift_left(id0,3))        ' return value = 11 bit identifier
    else
      read_msg = (shift_right(id3,3)) or (shift_left(id2,5)) or (shift_left(id1,13)) or (shift_left(id0,21))        ' return value = 29 bit identifier
    endif
  else
    read_msg = -1                                                  ' return value = 0
  endif

endfunction



'***************************************************************
' Transmits a frame.
' module: module address (0..255)
' channel: number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
' msg_no: number of the message object
' The databytes and the number of databytes have to be written in the
' array "can_msg" before this subroutine is activated.
' After this subroutine the frame is transmitted as soon as the
' CAN-bus allows it.
'***************************************************************

sub Transmit(module,channel,msg_no)
  dim merker as Long
  dim counter as Long

  for counter = 1 to can_msg[9]
    set_can_reg(module,channel, (msg_no * 10h)+counter+6,can_msg[counter])   'copy datas
  next counter


  ' Anzahl der Datenbytes bergeben
  merker = get_can_reg(module,channel, (msg_no * 10h)+6)       'read register
  merker = merker and 0fh                           'change DLC Bits
  merker = merker or shift_left(can_msg[9],4)
  set_can_reg(module,channel, msg_no *16 +6,merker)            'write register

  set_can_reg(module,channel, msg_no * 16 +1, 102)       ' Control register (setting bit to transmit data)
ENDSUB


'***************************************************************
' Enables the interrupt of a message object.
' module: module address (0..255)
' channel: number of the CAN interface on the CAN module
'          (also necessary if the module provides only one channel)
' msg_no: number of the message object
'***************************************************************
sub En_Interrupt(module,channel,msg_no)
  set_can_reg(module,channel, msg_no * 16, 0ebh)   'Enable interrupt of the message object.
  set_can_reg(module,channel, 0, 02h)     'Enable global interrupt.
endsub



'***************************************************************
' Sets a register of the CAN-controller.
' module: module address (0..255)
' regno: register which should be set
' value: value which should be written to the register.
'***************************************************************

sub Set_CAN_Reg(module,channel,regno, value)
  dim adr1 as Long
  dim adr2 as Long
  adr1 = 0c0h or (shift_left(module, 8)) or ((channel-1)*8)
  adr2 = adr1 or (1+((channel-1)*8))
#IF PROZESSOR = T9 THEN     'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
#IF PRIORITAET = LOW
  BEGIN_CRITICAL_SECTION
#ENDIF
#ENDIF
  poke(adwr ,adr2)
  nop_t9
  poke_nop(dlx ,regno)
  poke(adwr ,adr1)
  nop_t9
  poke_nop(dlx ,value)
#IF PROZESSOR = T9 THEN           'This part enables the interrupt.
#IF PRIORITAET = LOW
  END_CRITICAL_SECTION
#ENDIF
#ENDIF
endsub


'***************************************************************
' Reads a register of the CAN-controller.
' module: module address (0..255)
' channel: number of the CAN interface on the CAN module
'          (also necessary if the module provides only one channel)
' regno: register to read
' return value: value of the register
'***************************************************************

Function Get_CAN_Reg(module,channel,regno) as Long
  dim adr1 as Long
  dim adr2 as Long
  adr1 = 0c0h or (shift_left(module, 8)) or ((channel-1)*8)
  adr2 = adr1 or (2+((channel-1)*8))
#IF PROZESSOR = T9 THEN           'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
#IF PRIORITAET = LOW
  BEGIN_CRITICAL_SECTION
#ENDIF
#ENDIF
  poke(adwr ,adr2)
  nop_t9
  poke_nop(dlx ,regno)
#IF PROZESSOR = T5 THEN
  test =1*1*1*1
#ELSE
#IF PROZESSOR = T9 THEN
  sleep(6)
#ELSE
  test = SHIFT_LEFT(1,8)
#ENDIF
#ENDIF
  poke_nop(adrd ,adr1)
  get_can_reg = peek(dlx) and 255
#IF PROZESSOR = T9 THEN           'This part disables the interrupt.
#IF PRIORITAET = LOW
  END_CRITICAL_SECTION
#ENDIF
#ENDIF
endfunction


'***************************************************************
' Reads the register where the bus error pin of the tranceiver
'is stored.
' The register is set when the a bus error occurs and is reset by
' reading the register.
' module: module address (0..255)
' channel : number of the CAN interface on the CAN module
'          (also necessary if the module provides only one channel)
' return value : 0 = no error
'               1 = error
' Attention: This command is only for low-speed CAN
'***************************************************************

Function Get_Line_Status(module,channel) as Long
  dim adr as Long
  adr =  0c0h or shift_left(module, 8) or (3Dh - channel)
#IF PROZESSOR = T9 THEN           'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
#IF PRIORITAET = LOW
  BEGIN_CRITICAL_SECTION
#ENDIF
#ENDIF
  poke_nop(ADRD, adr)
  get_line_status = peek(DLX)
#IF PROZESSOR = T9 THEN           'This part disables the interrupt.
#IF PRIORITAET = LOW
  END_CRITICAL_SECTION
#ENDIF
#ENDIF
endfunction

'***************************************************************
' Function only for internal use.
'***************************************************************

function system_Round(value) as Long ''<HIDE>
  dim buffer as Float
  buffer = value + 0.5
  system_round = buffer
endfunction

'***************************************************************
' Function only for internal use.
'***************************************************************

function Int_Check(fl,int) as Long ''<HIDE>
  dim fbuffer as Float
  fbuffer = fl-int
  if ((fbuffer >= 0.00001) or (fbuffer <= -0.00001)) then
    int_check = 1       'not equal
  else
    int_check = 0       'equal
  endif
endfunction



'***************************************************************
' Sets the baudrate of the CAN-Bus.
' module: module address (0..255)
' channel: number of the CAN interface on the CAN module
'          (also necessary if the module provides only one channel)
' baud: CAN-Bus baudrate
' return value : 0 = baudrate is set
'       1 = the selected baudrate is not set
'***************************************************************

function Set_CAN_Baudrate(module,channel,baud) as Long
  dim scale as Long
  dim fbuffer as Float
  dim lbuffer as Long
  dim back as Long
  dim tseg1 as Long
  dim tseg2 as Long
  dim brp as Long
  dim btr0 as Long
  dim btr1 as Long
  set_can_baudrate = 0          'Initialisation
  fbuffer = 8000000 / baud
  scale = system_round(fbuffer)        'total scale to achive the baudrate
  set_can_baudrate = int_check(fbuffer,scale) '1 if baudrate not possible

  if (set_can_baudrate = 0) then      'If baudrate possible then find settings
    brp = (scale - 1) / 25        'Prescaler

    do              'find the right brp
      fbuffer = (scale / (brp + 1) - 3)
      lbuffer = system_round(fbuffer)
      back = int_check(fbuffer,lbuffer)   'inc prescaler until tseg1 + tseg 2 is an Long
      inc(brp)
    until((back = 0) or (fbuffer<5))
    dec(brp)
    if (back <> 0) then set_can_baudrate = 1
  endif

  if (set_can_baudrate = 0) then      'If there is a correct prescaler
    tseg2 = lbuffer * 0.4
    tseg1 = lbuffer - tseg2
    if (tseg2 > 7) then
      do
        dec(tseg2)
        inc(tseg1)
      until(tseg2 = 7)
    endif
    btr0 = brp            'Synchronization jump width = 1 (bits = 0)
    btr1 = tseg1 + shift_left(tseg2,4)    'one sampling each Bit
    set_can_reg(module,channel,0,65)      'enable access to btr regisers
    set_can_reg(module,channel,3fh,btr0)    'set btr0 regisers
    set_can_reg(module,channel,4fh,btr1)    'set btr1 regisers
    set_can_reg(module,channel,0,0)       'disable access to btr regisers
  endif
endfunction
'<ENDREGION>

'<REGION> Anybus
'-------------------Anybus

'*****************************************************************
' Gets a byte from the DPRAM of a profibus-DP master or slave.
' module: module address (0..255)
' bytenumber: number of the byte on the DPRAM
'*****************************************************************
function Get_Pro_Byte(module,bytenumber) as Long
  dim adr as Long
  adr = 80c0h or shift_left(module,13) or (bytenumber and 0ffffffc0h) *4h or (bytenumber and 63)
#IF PROZESSOR = T9 THEN           'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
#IF PRIORITAET = LOW
  BEGIN_CRITICAL_SECTION
#ENDIF
#ENDIF
  poke_nop(adrd, adr)
  get_pro_byte=peek(dlx)
#IF PROZESSOR = T9 THEN           'This part disables the interrupt.
#IF PRIORITAET = LOW
  END_CRITICAL_SECTION
#ENDIF
#ENDIF
endfunction

'*****************************************************************
' Sets a byte in the DPRAM of a profibus-DP master or slave.
' module: module address (0..255)
' bytenumber: number of the byte on the DPRAM
' value: value for the selected byte
'*****************************************************************
sub Set_Pro_Byte(module,bytenumber,value)
  dim adr as Long
  adr = 80c0h or shift_left(module,13) or (bytenumber and 0ffffffc0h) *4h or (bytenumber and 63)
#IF PROZESSOR = T9 THEN           'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
#IF PRIORITAET = LOW
  BEGIN_CRITICAL_SECTION
#ENDIF
#ENDIF
  poke(adwr, adr)
  nop_t9
  poke_nop(dlx, value)
#IF PROZESSOR = T9 THEN           'This part disables the interrupt.
#IF PRIORITAET = LOW
  END_CRITICAL_SECTION
#ENDIF
#ENDIF
endsub


'*****************************************************************
' Resets Hardware on the HMS module.
' module: module address (0..255)
'*****************************************************************
sub Hardware_Reset(module)
  dim adr as Long
  adr = 0c0h or (shift_left(module, 8)) or 39
#IF PROZESSOR = T9 THEN           'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
#IF PRIORITAET = LOW
  BEGIN_CRITICAL_SECTION
#ENDIF
#ENDIF
  poke(adwr, adr)
  nop_t9
  poke_nop(dlx, 1)
#IF PROZESSOR = T9 THEN           'This part disables the interrupt.
#IF PRIORITAET = LOW
  END_CRITICAL_SECTION
#ENDIF
#ENDIF
#IF PROZESSOR = T9 THEN           'Reset signal must be low for at least 5s
  sleep(50)
#ELSE
  wait(5)
#ENDIF
#IF PROZESSOR = T9 THEN           'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
#IF PRIORITAET = LOW
  BEGIN_CRITICAL_SECTION
#ENDIF
#ENDIF
  poke(adwr, adr)
  nop_t9
  poke_nop(dlx, 0)
#IF PROZESSOR = T9 THEN           'This part disables the interrupt.
#IF PRIORITAET = LOW
  END_CRITICAL_SECTION
#ENDIF
#ENDIF
#IF PROZESSOR = T9 THEN           'Wait until the module has finished his internal initialisation
  sleep(3000000)
#ELSE
  wait(300000)
#ENDIF
endsub



'Slave

'********************************************************
' Handles mailbox. When the in mailbox is set the mail is sent with this command.
' module: module address (0..255)
'********************************************************
sub send_mail(module)''<HIDE>
  dim buffer as Long
  buffer = get_pro_byte(module,app_ind)
  set_pro_byte(module,app_ind,buffer xor 80h)
endsub


'********************************************************
' Handles mailbox. If the in mailbox
' is free to handle a new mailbox communication the return
' value is 0 else the return value is 1.
' module: module address (0..255)
'********************************************************
function check_inbox_free(module) as Long ''<HIDE>
  dim buffer1 as Long
  dim buffer2 as Long
  buffer1 = get_pro_byte(module,app_ind) and 080h
  buffer2 = get_pro_byte(module,any_ind) and 080h
  if (buffer1 = buffer2) then
    check_inbox_free = 0
  else
    check_inbox_free = 1
  endif
endfunction

'********************************************************
' Handles mailbox. Checks if new
' data is in the out mailbox. If there is new data the
' return value is 0, else the return value is 1.
' module: module address (0..255)
'********************************************************
function check_outbox_full(module) as Long ''<HIDE>
  dim buffer1 as Long
  dim buffer2 as Long
  buffer1 = get_pro_byte(module,app_ind) and 040h
  buffer2 = get_pro_byte(module,any_ind) and 040h
  if (buffer1 = buffer2) then
    check_outbox_full = 1
  else
    check_outbox_full = 0
  endif
endfunction

'********************************************************
' Handles mailbox handling. The function is
' waiting until the in mailbox is free to handle a new
' mailbox communication. The return value is 0 when the
' waiting was successful, else the return value is 08000h.
' module: module address (0..255)
'********************************************************
function wait_inbox_free(module) as Long ''<HIDE>
  dim buffer1 as Long
  dim counter as Long
  counter = 0
  do
    inc counter
    buffer1 = check_inbox_free(module)
  until((counter > 10000000) or (buffer1 = 0))
  if (counter > 10000000) then
    wait_inbox_free = 08000h          'mail failed
  else
    wait_inbox_free = 0           'mail sended
  endif
endfunction

'********************************************************
' Handles mailbox. The function is
' waiting until the out mailbox is full to handle a new
' mailbox communication. The return value is 0 when the
' waiting was successful, else the return value is 04000h.
' module: module address (0..255)
'********************************************************
function wait_outbox_full(module) as Long ''<HIDE>
  dim buffer1 as Long
  dim counter as Long
  counter = 0
  do
    inc counter
    buffer1 = check_outbox_full(module)
  until((counter > 10000000) or (buffer1 = 0))
  if (counter > 10000000) then
    wait_outbox_full = 04000h         'mail failed
  else
    wait_outbox_full = 0          'mail sended
  endif
endfunction

'********************************************************
' Handles mailbox. If a new mail
' is in out mailbox and is read. This command gives an
' ACK. The next message can be received now.
' module: module address (0..255)
'********************************************************
sub ack_mail(module) ''<HIDE>
  dim buffer1 as Long
  dim buffer2 as Long
  buffer1 = get_pro_byte(module,any_ind) and 040h
  buffer2 = ((get_pro_byte(module,app_ind) and 0bfh) or buffer1)
  set_pro_byte(module,app_ind,buffer2)
endsub

'********************************************************
' Initialises the anybus module
' via mailbox. The in mailbox is set to start the
' initialisation.
' module: module address (0..255)
'********************************************************
sub set_mailbox_start_init(module) ''<HIDE>
  set_pro_byte(module,mail_in_0,000h)
  set_pro_byte(module,mail_in_1,001h)
  set_pro_byte(module,mail_in_2,040h)
  set_pro_byte(module,mail_in_3,001h)
  set_pro_byte(module,mail_in_4,000h)
  set_pro_byte(module,mail_in_5,001h)
  set_pro_byte(module,mail_in_6,000h)
  set_pro_byte(module,mail_in_7,000h)
  set_pro_byte(module,mail_in_8,000h)
  set_pro_byte(module,mail_in_9,001h)
  set_pro_byte(module,mail_in_a,000h)
  set_pro_byte(module,mail_in_b,001h)
  set_pro_byte(module,mail_in_c,000h)
  set_pro_byte(module,mail_in_d,000h)
  set_pro_byte(module,mail_in_e,000h)
  set_pro_byte(module,mail_in_f,000h)
endsub

'********************************************************
' Initialises the anybus module
' via mailbox. The in mailbox is set to terminate the
' initialisation.
' module: module address (0..255)
'********************************************************
sub set_mailbox_end_init(module) ''<HIDE>
  set_pro_byte(module,mail_in_0,000h)
  set_pro_byte(module,mail_in_1,001h)
  set_pro_byte(module,mail_in_2,040h)
  set_pro_byte(module,mail_in_3,001h)
  set_pro_byte(module,mail_in_4,000h)
  set_pro_byte(module,mail_in_5,003h)
  set_pro_byte(module,mail_in_6,000h)
  set_pro_byte(module,mail_in_7,000h)
  set_pro_byte(module,mail_in_8,000h)
  set_pro_byte(module,mail_in_9,001h)
  set_pro_byte(module,mail_in_a,000h)
  set_pro_byte(module,mail_in_b,001h)
  set_pro_byte(module,mail_in_c,000h)
  set_pro_byte(module,mail_in_d,000h)
  set_pro_byte(module,mail_in_e,000h)
  set_pro_byte(module,mail_in_f,000h)
endsub

'********************************************************
' Initialises of the anybus module
' via mailbox. The in mailbox is set to check the bus
' specific hardware.
' module: module address (0..255)
'********************************************************
sub set_mailbox_hw_chk(module) ''<HIDE>
  set_pro_byte(module,mail_in_0,000h)
  set_pro_byte(module,mail_in_1,001h)
  set_pro_byte(module,mail_in_2,040h)
  set_pro_byte(module,mail_in_3,001h)
  set_pro_byte(module,mail_in_4,000h)
  set_pro_byte(module,mail_in_5,006h)
  set_pro_byte(module,mail_in_6,000h)
  set_pro_byte(module,mail_in_7,000h)
  set_pro_byte(module,mail_in_8,000h)
  set_pro_byte(module,mail_in_9,001h)
  set_pro_byte(module,mail_in_a,000h)
  set_pro_byte(module,mail_in_b,001h)
  set_pro_byte(module,mail_in_c,000h)
  set_pro_byte(module,mail_in_d,000h)
  set_pro_byte(module,mail_in_e,000h)
  set_pro_byte(module,mail_in_f,000h)
endsub

'********************************************************
' Initialises the anybus module
' via mailbox. The in mailbox is set to configure the
' module according to the user defined values.
' module: module address (0..255)
'********************************************************
sub set_mailbox_anybus_init(module,IO_in,par_in,IO_out,par_out,input_handling,output_handling,interrupt) ''<HIDE>
  dim space_in, space_out as Long
  dim io_in_low,io_in_high,io_out_low,io_out_high,space_in_low,space_in_high,space_out_low,space_out_high as Long
  space_in = IO_in + par_in
  space_out = IO_out + par_out
  io_in_low = io_in and 0ffh
  io_in_high = shift_right(io_in,8) and 0ffh
  io_out_low = io_out and 0ffh
  io_out_high = shift_right(io_out,8) and 0ffh
  space_in_low = space_in and 0ffh
  space_in_high = shift_right(space_in,8) and 0ffh
  space_out_low = space_out and 0ffh
  space_out_high = shift_right(space_out,8) and 0ffh

  set_pro_byte(module,mail_in_0,000h)
  set_pro_byte(module,mail_in_1,00ah)
  set_pro_byte(module,mail_in_2,040h)
  set_pro_byte(module,mail_in_3,001h)
  set_pro_byte(module,mail_in_4,000h)
  set_pro_byte(module,mail_in_5,002h)
  set_pro_byte(module,mail_in_6,000h)
  set_pro_byte(module,mail_in_7,012h)
  set_pro_byte(module,mail_in_8,000h)
  set_pro_byte(module,mail_in_9,001h)
  set_pro_byte(module,mail_in_a,000h)
  set_pro_byte(module,mail_in_b,001h)
  set_pro_byte(module,mail_in_c,000h)
  set_pro_byte(module,mail_in_d,000h)
  set_pro_byte(module,mail_in_e,000h)
  set_pro_byte(module,mail_in_f,000h)

  set_pro_byte(module,0420h,io_in_high)
  set_pro_byte(module,0421h,io_in_low)
  set_pro_byte(module,0422h,space_in_high)
  set_pro_byte(module,0423h,space_in_low)
  set_pro_byte(module,0424h,space_in_high)
  set_pro_byte(module,0425h,space_in_low)
  set_pro_byte(module,0426h,io_out_high)
  set_pro_byte(module,0427h,io_out_low)
  set_pro_byte(module,0428h,space_out_high)
  set_pro_byte(module,0429h,space_out_low)
  set_pro_byte(module,042ah,space_out_high)
  set_pro_byte(module,042bh,space_out_low)
  set_pro_byte(module,042ch,input_handling)
  set_pro_byte(module,042dh,output_handling)
  set_pro_byte(module,042eh,000h)
  set_pro_byte(module,042fh,interrupt)
endsub

'********************************************************
' Checks if the responding mail to the
' start_init mail is ok. If ok return value is 0, else
' return value is 2.
' module: module address (0..255)
'********************************************************
function check_mailbox_start_init(module) as Long ''<HIDE>
  check_mailbox_start_init = 0
  if (get_pro_byte(module,mail_out_1) <> 01h) then check_mailbox_start_init = 2
  if (get_pro_byte(module,mail_out_3) <> 01h) then check_mailbox_start_init = 2
  if (get_pro_byte(module,mail_out_5) <> 01h) then check_mailbox_start_init = 2
  if (get_pro_byte(module,mail_out_7) <> 00h) then check_mailbox_start_init = 2
  if (get_pro_byte(module,mail_out_9) <> 01h) then check_mailbox_start_init = 2
  if (get_pro_byte(module,mail_out_b) <> 01h) then check_mailbox_start_init = 2
  if (get_pro_byte(module,mail_out_d) <> 00h) then check_mailbox_start_init = 2
  if (get_pro_byte(module,mail_out_f) <> 00h) then check_mailbox_start_init = 2
endfunction

'********************************************************
' Checks if the responding mail to the
' end_init mail is ok. If ok return value is 0, else
' return value is 080h.
' module: module address (0..255)
'********************************************************
function check_mailbox_end_init(module) as Long ''<HIDE>
  check_mailbox_end_init = 0
  if (get_pro_byte(module,mail_out_1) <> 01h) then check_mailbox_end_init = 080h
  if (get_pro_byte(module,mail_out_3) <> 01h) then check_mailbox_end_init = 080h
  if (get_pro_byte(module,mail_out_5) <> 03h) then check_mailbox_end_init = 080h
  if (get_pro_byte(module,mail_out_7) <> 00h) then check_mailbox_end_init = 080h
  if (get_pro_byte(module,mail_out_9) <> 01h) then check_mailbox_end_init = 080h
  if (get_pro_byte(module,mail_out_b) <> 01h) then check_mailbox_end_init = 080h
  if (get_pro_byte(module,mail_out_d) <> 00h) then check_mailbox_end_init = 080h
  if (get_pro_byte(module,mail_out_f) <> 00h) then check_mailbox_end_init = 080h
endfunction

'********************************************************
' Checks if the responding mail to the
' anybus_init mail is ok. If ok return value is 0, else
' return value is 4.
' module: module address (0..255)
'********************************************************
function check_mailbox_anybus_init(module) as Long ''<HIDE>
  check_mailbox_anybus_init = 0
  if (get_pro_byte(module,mail_out_1) <> 0ah) then check_mailbox_anybus_init = 4
  if (get_pro_byte(module,mail_out_3) <> 01h) then check_mailbox_anybus_init = 4
  if (get_pro_byte(module,mail_out_5) <> 02h) then check_mailbox_anybus_init = 4
  if (get_pro_byte(module,mail_out_7) <> 012h) then check_mailbox_anybus_init =4
  if (get_pro_byte(module,mail_out_9) <> 01h) then check_mailbox_anybus_init = 4
  if (get_pro_byte(module,mail_out_b) <> 01h) then check_mailbox_anybus_init = 4
  if (get_pro_byte(module,mail_out_d) <> 00h) then check_mailbox_anybus_init = 4
  if (get_pro_byte(module,mail_out_f) <> 00h) then check_mailbox_anybus_init = 4
  if (get_pro_byte(module,053eh) <> 00h) then check_mailbox_anybus_init = 4
  if (get_pro_byte(module,053fh) <> 00h) then check_mailbox_anybus_init = 4
endfunction

'********************************************************
' Checks if the responding mail to the
' hw_chk mail is ok. If ok return value is 0 else
' return value is 1.
' module: module address (0..255)
'********************************************************
function check_mailbox_hw_chk(module) as Long ''<HIDE>
  check_mailbox_hw_chk = 0
  if (get_pro_byte(module,mail_out_1) <> 01h) then check_mailbox_hw_chk = 1
  if (get_pro_byte(module,mail_out_3) <> 01h) then check_mailbox_hw_chk = 1
  if (get_pro_byte(module,mail_out_5) <> 06h) then check_mailbox_hw_chk = 1
  if (get_pro_byte(module,mail_out_7) <> 00h) then check_mailbox_hw_chk = 1
  if (get_pro_byte(module,mail_out_9) <> 01h) then check_mailbox_hw_chk = 1
  if (get_pro_byte(module,mail_out_b) <> 01h) then check_mailbox_hw_chk = 1
  if (get_pro_byte(module,mail_out_d) <> 00h) then check_mailbox_hw_chk = 1
  if (get_pro_byte(module,mail_out_f) <> 00h) then check_mailbox_hw_chk = 1
endfunction


'********************************************************
' Checks if the DPRAM is ok.
' If ok return value is 0, else return value is 040h.
' The elements of the watchdog and the handshake are not
' checked. This will result in errors.
' module: module address (0..255)
'********************************************************
function dpram_test(module) as Long ''<HIDE>
  dim counter as Long
  dim byte as Long
  dim buffer as Long
  dpram_test = 0
  for counter = 00h to 07d3h
    byte = get_pro_byte(module,counter)         'save value
    set_pro_byte(module,counter,(counter and 0ffh))     'write new value
    buffer = get_pro_byte(module,counter)         'check new value
    set_pro_byte(module,counter,byte)           'write back old value
    if (buffer <> (counter and 0ffh)) then dpram_test = 040h
  next counter
  for counter = 7d6h to 7fdh
    byte = get_pro_byte(module,counter)
    set_pro_byte(module,counter,(counter and 0ffh))
    buffer = get_pro_byte(module,counter)
    set_pro_byte(module,counter,byte)
    if (buffer <> (counter and 0ffh)) then dpram_test = 040h
  next counter
endfunction

'************************************************************************
' Initialises an anybus module.
'Attention: This function can only be used after power up.
'Attention: This function can only be used in a low init part.
'   Do not use in a high priority process.
'Attention: input and output size must be equal. (INTERBUS)
' module: module address (0..255)
'IO_in:   number of input bytes for fast data exchange
'par_in:    number of input bytes for parameter data exchange
'IO_out:    number of output bytes for fast data exchange
'par_out:   number of output bytes for parameter data exchange
'input_handling:  bit0: 0 = input area cleared on application stopped
'       1 = input area freezed on application stopped
'     bit1: 0 = changed data field not activated
'       1 = changed data field activated
'output_handling: bit0: 0 = Fieldbus OFF-line
'       1 = Fieldbus ON-line
'     bit1: 0 = output area cleared on fieldbus stopped
'       1 = output area freezed on fieldbus stopped
'interrupt:   bit0: 0 = no interrupt on data changed
'       1 = interrupt on data changed
'     bit1: 0 = no interrupt Fieldbus OFF-line
'       1 = interrupt Fieldbus OFF-line
'     bit2: 0 = no interrupt Fieldbus ON-line
'       1 = interrupt Fieldbus ON-line
'return value:  0 = no error; initialisation OK
'     bit1 = 0: anybus hardware_check failed
'     bit1 = 1: mailbox start_init failed
'     bit1 = 2: mailbox anybus_init failed
'     bit1 = 3: reseved for further use
'     bit1 = 4: reseved for further use
'     bit1 = 5: reseved for further use
'     bit1 = 6: dpram check failed
'     bit1 = 7: mailbox end_init failed
'     bit1 = 8: reseved for further use
'     bit1 = 9: reseved for further use
'     bit1 = 10:  reseved for further use
'     bit1 = 11:  reseved for further use
'     bit1 = 12:  reseved for further use
'     bit1 = 13:  reseved for further use
'     bit1 = 14:  mail was not received
'     bit1 = 15:  mail was not send
'************************************************************************
function Init_Slave(module,io_in,par_in,io_out,par_out,input_handling,output_handling,reserved) as Long
  dim buffer as Long
  init_slave = 0
  buffer = get_pro_byte(module,07ffh)     'clear interrupt
  buffer = 0

  'DPRAM_check (not via mailbox)
  buffer = dpram_test(module)
  init_slave = init_slave or buffer

  'Mailbox operations
  'Hardware_check
  buffer = wait_inbox_free(module)      'waiting until in mailbox is free
  init_slave = init_slave or buffer
  set_mailbox_hw_chk(module)        'setting the in mailbox
  send_mail(module)           'send mail
  buffer = wait_inbox_free(module)      'wait until in mail was send
  init_slave = init_slave or buffer
  buffer = wait_outbox_full(module)     'wait until out mail was received
  init_slave = init_slave or buffer
  buffer = check_mailbox_hw_chk(module)   'check out mail (hw ok)
  init_slave = init_slave or buffer
  ack_mail(module)            'acknowledge mail

  'start_init
  buffer = wait_inbox_free(module)      'waiting until in mailbox is free
  init_slave = init_slave or buffer
  set_mailbox_start_init(module)      'setting in mailbox
  send_mail(module)           'send mail
  buffer = wait_inbox_free(module)      'wait until in mail was send
  init_slave = init_slave or buffer
  buffer = wait_outbox_full(module)     'wait until out mail was received
  init_slave = init_slave or buffer
  buffer = check_mailbox_start_init(module)   'check out mail (init start ok)
  init_slave = init_slave or buffer
  ack_mail(module)            'acknowledge mail

  'anybus_init
  buffer = wait_inbox_free(module)      'waiting until in mailbox is free
  init_slave = init_slave or buffer
  set_mailbox_anybus_init(module,IO_in,par_in,IO_out,par_out,input_handling,output_handling,reserved)    'setting the in mailbox
  send_mail(module)           'send mail
  buffer = wait_inbox_free(module)      'wait until in mail was send
  init_slave = init_slave or buffer
  buffer = wait_outbox_full(module)     'wait until out mail was received
  init_slave = init_slave or buffer
  buffer = check_mailbox_anybus_init(module)  'check out mail (init anybus ok)
  init_slave = init_slave or buffer
  ack_mail(module)            'acknowledge mail

  'end_init
  buffer = wait_inbox_free(module)      'waiting until in mailbox is free
  init_slave = init_slave or buffer
  set_mailbox_end_init(module)        'setting in mailbox
  send_mail(module)           'send mail
  buffer = wait_inbox_free(module)      'wait until in mail was send
  init_slave = init_slave or buffer
  buffer = wait_outbox_full(module)     'wait until out mail was received
  init_slave = init_slave or buffer
  buffer = check_mailbox_end_init(module)   'check out mail (end init ok)
  init_slave = init_slave or buffer
  ack_mail(module)            'acknowledge mail
endfunction

'******************************************************
' Gives the information if the data in
' the out area has changen or not. If there is new data
' the return value is <> 0 else the return value is 0.
' module: module address (0..255)
' outsize: number of bytes of the out area.
'******************************************************
Function Changed_Data(module,outsize) as Long
  dim loopsize as Long
  dim buffer as Long
  dim count as Long
  changed_data = 0
  loopsize = (outsize - 1)/8 + 1
  for count = 1 to loopsize
    buffer = get_pro_byte(module,(count + 7E3h))
    changed_data = changed_data or buffer
  next count
endfunction


'******************************************************
' Requests application access to DPRAM.
' The DPRAM consists of 3 parts. Each part equals a bit
' in the parameter array:
' Bit 0:   Anybus control registers
' Bit 1:   Output data
' Bit 2:   Input data
' module: module address (0..255)
'******************************************************
sub Request_Access(module,area)
  dim buffer1 as Long
  buffer1 = get_pro_byte(module,app_ind) and 0f8H
  set_pro_byte(module,app_ind,((buffer1 or area) or 010h))
endsub

'******************************************************
' Requests application access release to DPRAM.
' The DPRAM consists of 3 parts. Each part equals a bit
' in the parameter area:
' Bit 0:   Anybus control registers
' Bit 1:   Output data
' Bit 2:   Input data
' module: module address (0..255)
'******************************************************
sub Request_Release_Access(module,area)
  dim buffer1 as Long
  buffer1 = get_pro_byte(module,app_ind) and 0e8H
  set_pro_byte(module,app_ind,(buffer1 or area))
endsub

'******************************************************
' Checks access right. If bit is set the application has
' access right.
' The DPRAM consists of 3 parts. Each part equals a bit
' in the parameter array:
' Bit 0:   Anybus control registers
' Bit 1:   Output data
' Bit 2:   Input data
' module: module address (0..255)
'******************************************************
function Check_Access(module) as Long
  Check_Access = get_pro_byte(module,any_ind) and 07h
endfunction

'*******************************************************
' Reads the input data from the DPRAM
' module: module address (0..255)
' array[]:   destination array for input data
' start:   first byte (DPRAM)
' count:   number of bytes
'*******************************************************
sub Get_Read_Buffer(module,array[],start,count)
  dim i as Long
  for i = start to (start + count - 1)
    array[i + 1 - start] = get_pro_byte(module,i)
  next i
endsub


'*******************************************************
' Writes the output data to the DPRAM
' module: module address (0..255)
' array[]: source array for input data
' start: first byte (DPRAM)
' count: number of bytes
'*******************************************************
sub Set_Write_Buffer(module,array[],start,count)
  dim i as Long
  for i = start to (start + count - 1)
    set_pro_byte(module,i,array[i+1])
  next i
endsub
'<ENDREGION>

'<REGION> Anybus master

'Master

'*******************************************************
' Gives access right to DPRAM to device.
' Set Pdcom and Pdack unequal.
' Data exchange mode 3 and 4.
' module: module address (0..255)
'*******************************************************
'  sub pass_access_3(module)
'  dim byte as Long
'  dim flag as Long
'    byte = (get_pro_byte(module,control_to_host) and 04h) xor 4
'    flag = (get_pro_byte(module,control_to_device) and 0bh)
'    byte = flag or byte
'    set_pro_byte(module,control_to_device,byte)
'  endsub


'*******************************************************
' Gives access right to DPRAM to device.
' Set Pdcom and Pdack equal.
' Data exchange mode 0 and 1.
' module: module address (0..255)
'*******************************************************
'  sub pass_access_0(module)
'  dim byte as Long
'  dim flag as Long
'    byte = (get_pro_byte(module,control_to_host) and 04h)
'    flag = (get_pro_byte(module,control_to_device) and 0bh)
'    byte = flag or byte
'    set_pro_byte(module,control_to_device,byte)
'  endsub



'*******************************************************
' Communicates via mailbox
' slave diagnostic
' module: module address (0..255)
' number: unique message number
' slave: ID of the selected slave
'*******************************************************
'  sub slave_diagnostic(module,number,slave)
'    set_pro_byte(module,out_mailbox_0,3)
'    set_pro_byte(module,out_mailbox_1,16)
'    set_pro_byte(module,out_mailbox_2,8)
'    set_pro_byte(module,out_mailbox_3,number)
'    set_pro_byte(module,out_mailbox_4,0)
'    set_pro_byte(module,out_mailbox_5,0)
'    set_pro_byte(module,out_mailbox_6,66)
'    set_pro_byte(module,out_mailbox_7,0)
'    set_pro_byte(module,out_mailbox_8,slave)
'    set_pro_byte(module,out_mailbox_9,0)
'    set_pro_byte(module,out_mailbox_a,0)
'    set_pro_byte(module,out_mailbox_b,0)
'    set_pro_byte(module,out_mailbox_c,0)
'    set_pro_byte(module,out_mailbox_d,32)
'    set_pro_byte(module,out_mailbox_e,5)
'    set_pro_byte(module,out_mailbox_f,1)
'  endsub




'*******************************************************
' Communicates via mailbox
' global control
' module: module address (0..255)
' number: unique number
' slave : 127 = all selected slaves (selected by group)
'     0 - 126 = only one slave (slavenumber)
' command:  20h = sync
'     10h = unsync
'     08h = freeze
'     04h = unfreeze
'     02h = clear
' group:  group for which the command is valid
'*******************************************************
'  sub global_control(module,number,slave,command,group)
'    set_pro_byte(module,out_mailbox_0,3)
'    set_pro_byte(module,out_mailbox_1,16)
'    set_pro_byte(module,out_mailbox_2,3)
'    set_pro_byte(module,out_mailbox_3,number)
'    set_pro_byte(module,out_mailbox_4,0)
'    set_pro_byte(module,out_mailbox_5,0)
'    set_pro_byte(module,out_mailbox_6,70)
'    set_pro_byte(module,out_mailbox_7,0)
'    set_pro_byte(module,out_mailbox_8,slave)
'    set_pro_byte(module,out_mailbox_9,command)
'    set_pro_byte(module,out_mailbox_a,group)
'  endsub

'*******************************************************
' Communicates via mailbox
' read statistic counter
' module: module address (0..255)
'   number: unique message number
'   start:  bus address of first slave
'   count:  number of slaves
'*******************************************************
'  sub statistic(module,number,start,count)
'    set_pro_byte(module,out_mailbox_0,7)
'    set_pro_byte(module,out_mailbox_1,16)
'    set_pro_byte(module,out_mailbox_2,8)
'    set_pro_byte(module,out_mailbox_3,number)
'    set_pro_byte(module,out_mailbox_4,0)
'    set_pro_byte(module,out_mailbox_5,0)
'    set_pro_byte(module,out_mailbox_6,0feh)
'    set_pro_byte(module,out_mailbox_7,0)
'    set_pro_byte(module,out_mailbox_8,start)
'    set_pro_byte(module,out_mailbox_9,0)
'    set_pro_byte(module,out_mailbox_a,0)
'    set_pro_byte(module,out_mailbox_b,0)
'    set_pro_byte(module,out_mailbox_c,0)
'    set_pro_byte(module,out_mailbox_d,count)
'    set_pro_byte(module,out_mailbox_e,5)
'    set_pro_byte(module,out_mailbox_f,1)
'  endsub


'*******************************************************
' Communicates via mailbox
' clear statistic counter
' module: module address (0..255)
'   number: unique message number
'*******************************************************
'  sub clear_statistic(module,number)
'    set_pro_byte(module,out_mailbox_0,7)
'    set_pro_byte(module,out_mailbox_1,16)
'    set_pro_byte(module,out_mailbox_2,8)
'    set_pro_byte(module,out_mailbox_3,number)
'    set_pro_byte(module,out_mailbox_4,0)
'    set_pro_byte(module,out_mailbox_5,0)
'    set_pro_byte(module,out_mailbox_6,0feh)
'    set_pro_byte(module,out_mailbox_7,0)
'    set_pro_byte(module,out_mailbox_8,0)
'    set_pro_byte(module,out_mailbox_9,0)
'    set_pro_byte(module,out_mailbox_a,0)
'    set_pro_byte(module,out_mailbox_b,0)
'    set_pro_byte(module,out_mailbox_c,0)
'    set_pro_byte(module,out_mailbox_d,0)
'    set_pro_byte(module,out_mailbox_e,5)
'    set_pro_byte(module,out_mailbox_f,4)
'  endsub



'*******************************************************
' Communicates via Mailbox
' check if requested message is arrived
' module: module address (0..255)
' return value :  1 = message arrived
'        2 = message not arrived
'*******************************************************
'  function check_msg(module) as Long
'  dim byte as Long
'  dim flag as Long
'    byte = get_pro_byte(module,control_to_host) and 02h
'    flag = get_pro_byte(module,control_to_device) and 02h
'    par_3 = flag
'    par_4 = byte
'    if (byte = flag) then
'      check_msg = 1         ' message arrived
'    else
'      check_msg = 2         ' message not arrived
'    endif
'  endfunction
'


'*******************************************************
' Communicates via mailbox.
'Sending message to note.
'After the initialisation of the Out_mailbox the message
'must be send to the profibus.
' module: module address (0..255)
'*******************************************************
'  sub send_msg_to_note(module)
'  dim byte as Long
'  dim flag as Long
'    byte = ((get_pro_byte(module,control_to_host) and 02h) xor 02h)
'    flag = (get_pro_byte(module,control_to_device))
'    flag = (flag and 0dh) or byte
'    set_pro_byte(module,control_to_device,flag)
'  endsub


'*******************************************************
' Gives acknoledge to arrived message
' module: module address (0..255)
'*******************************************************
'  sub ack_msg(module)
'  dim byte as Long
'    byte = get_pro_byte(module,control_to_host) and 03h
'    set_pro_byte(module,control_to_device, byte)
'  endsub
'

'*******************************************************
' Resets the Master Module
' access_mode:  0 = bus synchronus ; device controlled
'       1 = bufferd ; device controlled
'       2 = uncontrolled
'       3 = bufferd ; user controlled
'       4 = bus synchronus ; user controlled
' module: module address (0..255)
'*******************************************************
'  sub reset_master(module,access_mode)
'    set_pro_byte(module,set_exchange_mode,access_mode)    'set access mode
'    set_pro_byte(module,control_to_device,080h)     'set reset flag
'  endsub


'*******************************************************
'Initialises the Master Module
' access_mode:  0 = bus synchronus ; device controlled
'       1 = bufferd ; device controlled
'       2 = uncontrolled
'       3 = bufferd ; user controlled
'       4 = bus synchronus ; user controlled
' module: module address (0..255)
'*******************************************************
'  sub init_master(module,access_mode)
'  dim mode as Long
'    set_pro_byte(module,set_exchange_mode,access_mode)
'    set_pro_byte(module,control_to_device,040h)
'  endsub


'*******************************************************
'Checks if the device or the host has access right
'function only valid in access_mode 0 and 1
' module: module address (0..255)
' return value :  1 = host
'       2 = device
'*******************************************************
'  function check_access_0(module) as Long
'  dim byte as Long
'  dim flag as Long
'    byte = get_pro_byte(module,control_to_host) and 04h
'    flag = get_pro_byte(module,control_to_device) and 04h
'    if (flag <> byte) then
'      check_access_0 = 1
'    else
'      check_access_0 = 2
'    endif
'  endfunction

'*******************************************************
' Checks if the device or the host has access right
' function only valid in access_mode 3 and 4
' module: module address (0..255)
' return value :  1 = host
'       2 = device
'*******************************************************
'  function check_access_3(module) as Long
'  dim byte as Long
'  dim flag as Long
'    byte = get_pro_byte(module,control_to_host) and 04h
'    flag = get_pro_byte(module,control_to_device) and 04h
'    if (flag = byte) then
'      check_access_3 = 1
'    else
'      check_access_3 = 2
'    endif
'  endfunction



'*******************************************************
' Shows the statue of the master
' module: module address (0..255)
'bit7:  1 = device is ready
'   0 = device is not ready
'bit6:  1 = communication is running
'   0 = communication is not running
'bit5:  1 = data is getting exchanged
'   0 = no data exchanged
'*******************************************************
'  function master_status(module) as Long
'    master_status = get_pro_byte(module,control_to_host) and 0f0h
'  endfunction
'<ENDREGION>

#ENDIF 'ADSP
#ENDIF 'not T11
