'<ADbasic Header, Headerversion 001.001>
' Foldings                       = 27,900,937
'<Header End>
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--Inc--PRO
'<SMARTFORMAT OFF> do not remove !!!
'
'#################################################################
'#                        ADwinPRO2Common.inc                    #
'#              INCLUDE-file for ADwin-Pro II-system             #
'#################################################################
'#                                                               #
'# Contents: Definition of functions and procedures              #
'#           to access ADwin PRO 2 SYSTEM                        #
'#                                                               #
'#  30.10.2018  mf   creation                                    #
'#  09.01.2019  ol   Profibus, Profinet, Ethercat integrated     #
'#  07.05.2020  ol   Profinet bugfix/64 DWORDs                   #
'#  26.10.2020  mf   new P2_Comp_Set_Voltage                     #
'#  19.01.2021  mf   new internal command                        #
'#  24.08.2021  mf   IEPE (Beta)                                 #
'# Attention:                                                    #
'#   - Do not copy the first source line (containing             #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !                #
'#     Otherwise the Syntax color may be not correct.            #
'#   - This includefile requires ADbasic 6 or higher!            #
'#                                                               #
'#################################################################


'<REGION> ANYBUS CC M40
#define AB_START_MSG_HEADER_OUT   800h                                          ''<HIDE>   
#define AB_START_MSG_HEADER_IN    400h                                          ''<HIDE> 
#define AB_MSG_DATA_SIZE 0                                                      ''<HIDE>   
#define AB_MSG_SOURCE_ID_OBJ 2                                                  ''<HIDE>       
#define AB_MSG_INSTANCE 3                                                       ''<HIDE> 
#define AB_MSG_COMMAND 4                                                        ''<HIDE>       
#define AB_MSG_CMD_EXT 5                                                        ''<HIDE>
#define AB_MSG_DATA 6                                                           ''<HIDE>
                      
#define AB_SOURCE_ID_OUT 03FEH                                                  ''<HIDE>  
#define AB_OBJECT_OUT 03FFH                                                     ''<HIDE>          

#define MSG_SETUP_COMPLETE 8                                                    ''<HIDE>                                 

#define ABP_MSG_HEADER_C_BIT        040h                                        ''<HIDE>                                 
#define ABP_MSG_HEADER_E_BIT        080h                                        ''<HIDE>                                 
#define ABP_MSG_HEADER_CMD_BITS     03Fh                                        ''<HIDE>                                 

#define ABP_CMD_GET_ATTR 01h              'Get attribute                        ''<HIDE>
#define ABP_CMD_SET_ATTR 02h              'Set attribute                        ''<HIDE>

#define ABP_BOOL_SIZEOF             1     'Boolean                              ''<HIDE>     
#define ABP_ANB_IA_SETUP_COMPLETE   5                                           ''<HIDE>
#define ABP_ANB_STATE_PROCESS_ACTIVE 4                                          ''<HIDE>
#define ABS_BIT_ANB_STATE 07H                                                   ''<HIDE> 

#define ABS_BIT_CMDCNT 06H                                                      ''<HIDE> 
#define ABS_BIT_CRC 0100H                                                       ''<HIDE>
#define ABS_BIT_SPI_EOF 0001H                                                   ''<HIDE>
#define ABS_BIT_SPI_CTRL_PD_VALID 001H     'Process data from ADwin is valid    ''<HIDE>
#define ABS_BIT_SPI_CTRL_CMDCNT 006H       'ADwin is fast enough to process all amounts of data           ''<HIDE>
#define ABS_BIT_SPI_CTRL_M 008H                                                 ''<HIDE>
#define ABS_BIT_SPI_CTRL_LAST 010H                                              ''<HIDE>
#define ABS_BIT_SPI_CTRL_TOGGLE 080H                                            ''<HIDE>

#define ABS_BIT_ANB_STAT_S 07H                                                  ''<HIDE>
#define ABS_BIT_SPI_STAT_M 008H                                                 ''<HIDE>
#define ABS_BIT_SPI_STAT_LAST 010H                                              ''<HIDE>


#define ABS_SPI_STATE 25                                                        ''<HIDE>
#define ABS_SPI_STATE_INIT 1                                                    ''<HIDE>
#define ABS_SPI_STATE_WRITE 2                                                   ''<HIDE>
#define ABS_SPI_STATE_START_CYCLE 3                                             ''<HIDE>    
#define ABS_SPI_STATE_CHECK_STATE 4                                             ''<HIDE>
#define ABS_SPI_STATE_READ 5                                                    ''<HIDE>
#define ABS_SPI_MSG_SIZE 26                                                     ''<HIDE>
#define ABS_SPI_PD_SIZE 27                                                      ''<HIDE>
#define ABS_SPI_HDL 28                                                          ''<HIDE>
#define ABS_SPI_CYCLE_CNT 29                                                    ''<HIDE>  
#define ABS_SPI_ERROR_CNT 30                                                    ''<HIDE>
#define ABS_LED_STAT 31                                                         ''<HIDE>
#define ABS_ANB_STAT 32                                                         ''<HIDE>
#define ABS_SPI_STAT 33                                                         ''<HIDE>
#define ABS_NETTIME 34                                                          ''<HIDE>
#define ABS_SPI_CTRL 35                                                         ''<HIDE>
#define ABS_SPI_APP_STATE 36                                                    ''<HIDE>
#define ABS_SPI_INT_MASK 37                                                     ''<HIDE>
'#define ABS_MSG_OUT_PENDING 38                                                  ''<HIDE>
#define ABS_DO_MSG 39                                                           ''<HIDE>
#define AB_ERROR_BASE 40                                                        ''<HIDE>
#define AB_ERROR_Extention1 41                                                  ''<HIDE>
#define AB_ERROR_Extention2 42                                                  ''<HIDE>
#define AB_ERROR_Extention3 43                                                  ''<HIDE>
#define AB_OUTSTANDING_COMMANDS 44                                              ''<HIDE>
#define AB_CmdState 45                                                          ''<HIDE>
#define AB_PROC_TYPE_IN 46                                                      ''<HIDE>
#define AB_PROC_CNT_IN 47                                                       ''<HIDE>
#define AB_PROC_TYPE_OUT 48                                                     ''<HIDE>  
#define AB_PROC_CNT_OUT 49                                                      ''<HIDE>
#define ABS_SPI_NEW 50                                                          ''<HIDE>  
#define AB_INSTANCE_READ_REQUEST 51                                             ''<HIDE>
#define AB_READ_SOURCE_ID 52                                                    ''<HIDE>  
#define AB_READ_OBJ_NUM 53                                                      ''<HIDE>
#define AB_READ_INST_NUM 54                                                     ''<HIDE>  
#define AB_READ_ATTR_NUM 55                                                     ''<HIDE>
#define AB_MAPPING_CNT_IN 56                                                    ''<HIDE>
#define AB_MAPPING_CNT_OUT 57                                                   ''<HIDE>
#define AB_MAPPING_SIZE_IN 58                                                   ''<HIDE>
#define AB_MAPPING_SIZE_OUT 59                                                  ''<HIDE>
#define AB_MAPPING_DATA_TYPE 60                                                 ''<HIDE>
#define AB_DATA_TYPE_SINT32 3                                                   ''<HIDE>
#define AB_DATA_TYPE_UINT32 6                                                   ''<HIDE>
#define AB_DATA_TYPE_FLOAT 18                                                   ''<HIDE>
#define AB_DIR_IN 1                                                             ''<HIDE>  
#define AB_DIR_OUT 2                                                            ''<HIDE>  
#define AB_MAPPING_DEV_ADR 61                                                   ''<HIDE>
#define AB_MODUL_NUMBER 62                                                      ''<HIDE>
#define ABP_BUFFER_CONTROL_IDX 63                                               ''<HIDE>
#define ABP_TEMP_IDX 64                                                         ''<HIDE>
#define ABP_STATUS_REGISTER_IDX 65                                              ''<HIDE>
#define AB_USER_BUS_TYPE 66                                                     ''<HIDE>


#define ABP_BUFFER_CONTROL_ADR 01FFCH                                           ''<HIDE>
#define ABP_STATUS_REGISTER_ADR 01FFBH                                          ''<HIDE>
#define ABP_BIT_WRPD 01H                                                        ''<HIDE>
#define ABP_BIT_RDPD 02H                                                        ''<HIDE>
#define ABP_BIT_WRMSG 04H                                                       ''<HIDE>
#define ABP_BIT_RDMSG 08H                                                       ''<HIDE>
#define ABP_BIT_ANBR 010H                                                       ''<HIDE>
#define ABP_BIT_APPR 020H                                                       ''<HIDE>
#define ABP_PROCESS_DATA_WRITE_ADR 00000H                                       ''<HIDE>
#define ABP_PROCESS_DATA_READ_ADR 00800H                                        ''<HIDE>
#define ABP_MSG_DATA_WRITE_ADR 01000H                                           ''<HIDE>
#define ABP_MSG_DATA_READ_ADR 01800H                                            ''<HIDE>
#define ABP_MSG_DATA_LENGH 1536                                                 ''<HIDE>
'From this point the definitions are imported from the HMS C-driver example
'------------------------------------------------------------------------------
' Host application objects
'------------------------------------------------------------------------------

#define ABP_OBJ_NUM_PNIO            246   'PROFINET IO                          ''<HIDE>
#define ABP_OBJ_NUM_CCL             247   'CC-Link                              ''<HIDE>                    
#define ABP_OBJ_NUM_EIP             248   'EtherNet/IP                          ''<HIDE>
#define ABP_OBJ_NUM_ETN             249   'Ethernet                             ''<HIDE>
#define ABP_OBJ_NUM_MOD             250   'Modbus                               ''<HIDE>
#define ABP_OBJ_NUM_COP             251   'CANopen                              ''<HIDE>
#define ABP_OBJ_NUM_DEV             252   'DeviceNet                            ''<HIDE>
#define ABP_OBJ_NUM_DPV1            253   'PROFIBUS DP-V1                       ''<HIDE>
#define ABP_OBJ_NUM_APPD            254   'Application Data                     ''<HIDE>
#define ABP_OBJ_NUM_APP             255   'Application                          ''<HIDE>

'------------------------------------------------------------------------------
'State variable that keeps track of which initialization command to send next
'It is also used as a "source ID" to simplify the identification of responses
'from the Anybus-CC.
'------------------------------------------------------------------------------
#define MSG_INIT 0                                                              ''<HIDE>
#define MSG_NODE_ADR 1                                                          ''<HIDE>                   
#define MSG_BAUDRATE 2                                                          ''<HIDE>                                                          
#define MSG_MAP_IO_1 3                                                          ''<HIDE>
#define MSG_MAP_IO_2 4                                                          ''<HIDE>  
#define MSG_MAP_IO_3 5                                                          ''<HIDE>
#define MSG_MAP_IO_4 6                                                          ''<HIDE> 
#define MSG_DATA_FORMAT 7                                                       ''<HIDE>
#define MSG_SETUP_COMPLETE 8                                                    ''<HIDE>
#define MSG_DONE 9                                                              ''<HIDE> 
#define MSG_READ_REQUEST 10                                                     ''<HIDE>

'------------------------------------------------------------------------------
'Anybus module objects
'------------------------------------------------------------------------------

#define ABP_OBJ_NUM_ANB               1   'Anybus                               ''<HIDE>     
#define ABP_OBJ_NUM_DI                2   'Diagnostic                           ''<HIDE>
#define ABP_OBJ_NUM_NW                3   'Network                              ''<HIDE>
#define ABP_OBJ_NUM_NC                4   'Network Configuration                ''<HIDE>
#define ABP_OBJ_NUM_ADD               5   'PROFIBUS DP-V1 Additional Diag       ''<HIDE>
#define ABP_OBJ_NUM_RSV1              6   'Reserved                             ''<HIDE>
#define ABP_OBJ_NUM_SOC               7   'Socket Interface                     ''<HIDE>
#define ABP_OBJ_NUM_NWCCL             8   'Network CC-Link                      ''<HIDE>
#define ABP_OBJ_NUM_SMTP              9   'SMTP Client                          ''<HIDE>
#define ABP_OBJ_NUM_FSI              10   'File System Interface                ''<HIDE>
#define ABP_OBJ_NUM_NWDPV1           11   'Network PROFIBUS DP-V1               ''<HIDE>
#define ABP_OBJ_NUM_NWETN            12   'Network Ethernet                     ''<HIDE>
#define ABP_OBJ_NUM_CPC              13   'CIP Port Configuration               ''<HIDE>
#define ABP_OBJ_NUM_NWPNIO           14   'Network PROFINET IO                  ''<HIDE>
#define ABP_OBJ_NUM_PNIOADD          15   'PROFINET IO Additional Diag          ''<HIDE>

'------------------------------------------------------------------------------
'The Network object specific message commands.
'------------------------------------------------------------------------------

#define ABP_NW_CMD_MAP_ADI_WRITE_AREA        010h                               ''<HIDE>                            
#define ABP_NW_CMD_MAP_ADI_READ_AREA         011h                               ''<HIDE>
#define ABP_NW_CMD_MAP_ADI_WRITE_EXT_AREA    012h                               ''<HIDE>                            
#define ABP_NW_CMD_MAP_ADI_READ_EXT_AREA     013h                               ''<HIDE>

'The object instance number.
'------------------------------------------------------------------------------

#define ABP_INST_OBJ                0                                           ''<HIDE>

'------------------------------------------------------------------------------
'The object standard attributes.
'------------------------------------------------------------------------------

#define ABP_OA_NAME                 1     'Object name                          ''<HIDE>
#define ABP_OA_REV                  2     'Object revision                      ''<HIDE>
#define ABP_OA_NUM_INST             3     'Current number of instances          ''<HIDE>
#define ABP_OA_HIGHEST_INST         4     'Current highest instance number      ''<HIDE>

'------------------------------------------------------------------------------
'The data size of the object standard attributes (in bytes).
'------------------------------------------------------------------------------

#define ABP_OA_REV_DS               1                                           ''<HIDE>
#define ABP_OA_NUM_INST_DS          2                                           ''<HIDE>
#define ABP_OA_HIGHEST_INST_DS      2                                           ''<HIDE>
'------------------------------------------------------------------------------
'The Application data object specific message commands.
'------------------------------------------------------------------------------

#define ABP_APPD_CMD_GET_INST_BY_ORDER    010h                                  ''<HIDE>
#define ABP_APPD_CMD_GET_NEXT_GUARDED     011h                                  ''<HIDE>
#define ABP_APPD_CMD_GET_INST_NUMBERS     015h                                  ''<HIDE>
#define ABP_APPD_CMD_GET_ATTR_NAME        001h                                  ''<HIDE>
#define ABP_APPD_CMD_GET_ATTR_DATA_TYPE   002h                                  ''<HIDE>
#define ABP_APPD_CMD_GET_ATTR_NO_ELEMENTS 003h                                  ''<HIDE>
#define ABP_APPD_CMD_GET_ATTR_DISCRIPTOR  004h                                  ''<HIDE>


'Networktypes
#define AB_NETWORK_TYPE_PROFINET_IRT      089H                                  ''<HIDE>
#define AB_NETWORK_TYPE_PROFINET_FO       09DH                                  ''<HIDE>
#define AB_NETWORK_TYPE_PROFIBUS          005H                                  ''<HIDE>
#define AB_NETWORK_TYPE_ETHERCAT          087H                                  ''<HIDE>

'ADWIN ERRORCODES
#define AB_ERROR_CODE_UNSUP_OBJECT 3                                            ''<HIDE>
#define AB_ERROR_CODE_UNSUP_INSTANCE 4                                          ''<HIDE>
#define AB_ERROR_CODE_ATTR_NOT_GETTABLE 6                                       ''<HIDE>
#define AB_ERROR_CODE_UNSUP_COMMAND 5                                           ''<HIDE>
#define AB_ERROR_CODE_SETUP_FAILED 20                                            ''<HIDE>

#define AB_TRUE 1                                                               ''<HIDE>                               
#define AB_FALSE 0                                                              ''<HIDE>
#define AB_SENT 2                                                               ''<HIDE>
#define AB_HEADER_SIZE 6                                                        ''<HIDE>
#define AB_SPI_SEND_SIZE 32                                                     ''<HIDE>
'''min. length of work array
#define AB_WORK_ARR_LEN 5000


'***************************************************************
'''Reads and writes process data from/to Anybus module and 
'''+handles mailbox communication to the module.
'''+return value:
'''+         0: Setup
'''+         2: Wait
'''+         4: Active
'''+     other: Error (configuration correct?)
'''module: module address (1..15)
'''in_pd_arr[]: array for input data
'''out_pd_arr[]: array with output data
'''in_pd_arr_len: number of input elements
'''out_pd_arr_len: number of output elements
'''work_arr[]: array for communication ADwin processor <-> Anybus module 
'''+ min. size AB_WORK_ARR_LEN 
'''flowrate: 
'''+         1=low
'''+         2=medium
'''+         3=fast
'''***************************************************************
FUNCTION Run_ANYBUS_CC_M40(module,in_pd_arr[], out_pd_arr[], in_pd_arr_len, out_pd_arr_len, work_arr[],flowrate) AS LONG  ''<HIDE>
  DIM map_cnt_in, map_cnt_out, id_counter,i AS LONG
  Check_Type_Long (work_arr[1])
  System_Array_Debug_Check(work_arr, 1, AB_WORK_ARR_LEN)
  P2_M40_GET_RAM(module,work_arr,ABP_STATUS_REGISTER_IDX,ABP_STATUS_REGISTER_ADR,1,flowrate,16)
  P2_M40_GET_RAM(module,work_arr,ABP_BUFFER_CONTROL_IDX,ABP_BUFFER_CONTROL_ADR,1,flowrate,16)   
  IF ((work_arr[ABP_BUFFER_CONTROL_IDX] AND ABP_BIT_RDMSG) = ABP_BIT_RDMSG) THEN       'There is a message available.
    P2_M40_GET_RAM(module,work_arr,AB_START_MSG_HEADER_IN,ABP_MSG_DATA_READ_ADR,ABP_MSG_DATA_LENGH,flowrate,16)   'Read Message
    work_arr[AB_START_MSG_HEADER_IN + AB_OBJECT_OUT] = SHIFT_RIGHT(work_arr[AB_START_MSG_HEADER_IN + AB_MSG_SOURCE_ID_OBJ],8)
    work_arr[AB_START_MSG_HEADER_IN + AB_SOURCE_ID_OUT] = work_arr[AB_START_MSG_HEADER_IN + AB_MSG_SOURCE_ID_OBJ] AND 0FFH
    work_arr[ABP_TEMP_IDX] = ABP_BIT_RDMSG + ABP_BIT_APPR
    P2_M40_SET_RAM(module,work_arr,ABP_TEMP_IDX,ABP_BUFFER_CONTROL_ADR,1,flowrate,16)                   'Message ACK
    P2_M40_GET_RAM(module,work_arr,ABP_BUFFER_CONTROL_IDX,ABP_BUFFER_CONTROL_ADR,1,flowrate,16)   
    IF ((work_arr[AB_START_MSG_HEADER_IN + AB_MSG_COMMAND] AND ABP_MSG_HEADER_C_BIT) = ABP_MSG_HEADER_C_BIT) THEN 'Message is a command
      FOR i = 0 TO AB_HEADER_SIZE
        work_arr[AB_START_MSG_HEADER_OUT + i] = work_arr[AB_START_MSG_HEADER_IN + i]
      NEXT i
      work_arr[AB_START_MSG_HEADER_OUT + AB_SOURCE_ID_OUT] = work_arr[AB_START_MSG_HEADER_IN + AB_SOURCE_ID_OUT]
      work_arr[AB_START_MSG_HEADER_OUT + AB_OBJECT_OUT] = work_arr[AB_START_MSG_HEADER_IN + AB_OBJECT_OUT]
      work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] AND NOT(ABP_MSG_HEADER_C_BIT)
      SELECTCASE work_arr[AB_START_MSG_HEADER_IN + AB_OBJECT_OUT]
        CASE ABP_OBJ_NUM_APPD
          work_arr[ABS_DO_MSG] = AB_TRUE
          IF (ApplicationDataObject(work_arr) = AB_FALSE) THEN 
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] OR (ABP_MSG_HEADER_E_BIT)
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 1
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = work_arr[AB_ERROR_BASE]
          ENDIF
        CASE ABP_OBJ_NUM_APP
          work_arr[ABS_DO_MSG] = AB_TRUE
          IF (ApplicationObject(work_arr) = AB_FALSE) THEN
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] OR (ABP_MSG_HEADER_E_BIT)
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 1
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = work_arr[AB_ERROR_BASE]
          ENDIF
        CASEELSE
          work_arr[AB_ERROR_BASE] = AB_ERROR_CODE_UNSUP_OBJECT
          work_arr[AB_ERROR_Extention1] = work_arr[AB_START_MSG_HEADER_IN + AB_OBJECT_OUT]
          work_arr[ABS_DO_MSG] = AB_TRUE
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 1
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = work_arr[AB_ERROR_BASE]
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] OR (ABP_MSG_HEADER_E_BIT)
      ENDSELECT
    ELSE 'Message is a response to a command we have sent
      DEC work_arr[AB_OUTSTANDING_COMMANDS]
      SELECTCASE work_arr[AB_START_MSG_HEADER_IN + AB_SOURCE_ID_OUT]
        CASE MSG_SETUP_COMPLETE
          IF ((work_arr[AB_START_MSG_HEADER_IN + AB_MSG_COMMAND] AND ABP_MSG_HEADER_E_BIT) = ABP_MSG_HEADER_E_BIT) THEN
            work_arr[AB_ERROR_BASE] = AB_ERROR_CODE_SETUP_FAILED
          ENDIF
      ENDSELECT
    ENDIF
  ENDIF  ' End of message availible
  
  IF ((((work_arr[ABP_BUFFER_CONTROL_IDX] AND ABP_BIT_WRMSG) = 0) AND ((work_arr[ABP_BUFFER_CONTROL_IDX] AND ABP_BIT_ANBR) = ABP_BIT_ANBR)) AND (work_arr[ABS_DO_MSG] = AB_FALSE)) THEN 'The Anybus-CC is ready to accept commands, and the WriteMsg buffer is free
    SELECTCASE work_arr[AB_CmdState]
      CASE MSG_INIT
        map_cnt_in = 0
        map_cnt_out = 0
        id_counter = 0
        work_arr[AB_OUTSTANDING_COMMANDS] = 0
        work_arr[ABS_DO_MSG] = AB_FALSE
        work_arr[AB_CmdState] = MSG_NODE_ADR
      CASE MSG_NODE_ADR
        IF (work_arr[AB_MAPPING_DEV_ADR] <> 0) THEN
          inc id_counter
          work_arr[AB_START_MSG_HEADER_OUT + AB_SOURCE_ID_OUT] = id_counter and 0ffH
          work_arr[AB_START_MSG_HEADER_OUT + AB_OBJECT_OUT] = ABP_OBJ_NUM_NC
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_INSTANCE] = 1
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = ABP_MSG_HEADER_C_BIT OR ABP_CMD_SET_ATTR
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 1
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_CMD_EXT] = 5                        'Node ID
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = work_arr[AB_MAPPING_DEV_ADR]
          work_arr[ABS_DO_MSG] = AB_TRUE
        ENDIF
        work_arr[AB_CmdState] = MSG_MAP_IO_1
      CASE MSG_MAP_IO_1
        inc id_counter
        work_arr[AB_START_MSG_HEADER_OUT + AB_SOURCE_ID_OUT] =  id_counter and 0ffH
        work_arr[AB_START_MSG_HEADER_OUT + AB_OBJECT_OUT] = ABP_OBJ_NUM_NW
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_INSTANCE] = 1
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = ABP_MSG_HEADER_C_BIT OR ABP_NW_CMD_MAP_ADI_WRITE_EXT_AREA
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 7
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_CMD_EXT] = 1
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 1 + map_cnt_out
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 1] = work_arr[AB_MAPPING_SIZE_OUT]
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 2] = 0100H OR work_arr[AB_MAPPING_SIZE_OUT] 
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 3] = work_arr[AB_PROC_TYPE_OUT]
        work_arr[ABS_DO_MSG] = AB_TRUE
        INC  map_cnt_out
        IF (work_arr[AB_MAPPING_CNT_OUT] = map_cnt_out) THEN work_arr[AB_CmdState] = MSG_MAP_IO_3
      CASE MSG_MAP_IO_3
        inc id_counter
        work_arr[AB_START_MSG_HEADER_OUT + AB_SOURCE_ID_OUT] = id_counter and 0ffH
        work_arr[AB_START_MSG_HEADER_OUT + AB_OBJECT_OUT] = ABP_OBJ_NUM_NW
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_INSTANCE] = 1
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = ABP_MSG_HEADER_C_BIT OR ABP_NW_CMD_MAP_ADI_READ_EXT_AREA
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 7
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_CMD_EXT] = 1
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 1 + map_cnt_out + map_cnt_in 
        IF(work_arr[AB_USER_BUS_TYPE] = ABP_OBJ_NUM_PNIO) THEN work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 6 + map_cnt_in 'Profinet
        IF(work_arr[AB_USER_BUS_TYPE] = ABP_OBJ_NUM_DPV1) THEN work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 6 + map_cnt_in 'Profibus
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 1] = work_arr[AB_MAPPING_SIZE_IN]
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 2] = 0100H OR work_arr[AB_MAPPING_SIZE_IN] 
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 3] = work_arr[AB_PROC_TYPE_IN]
        work_arr[ABS_DO_MSG] = AB_TRUE
        INC  map_cnt_in
        IF (work_arr[AB_MAPPING_CNT_IN] = map_cnt_in) THEN work_arr[AB_CmdState] = MSG_SETUP_COMPLETE
      CASE MSG_SETUP_COMPLETE
        'All the configuration commands have been processed by the Anybus - CC.
        'Go ahead and end the setup phase by sending SETUP_COMPLETE.
        inc id_counter
        work_arr[AB_START_MSG_HEADER_OUT + AB_SOURCE_ID_OUT] = id_counter and 0ffH
        work_arr[AB_START_MSG_HEADER_OUT + AB_OBJECT_OUT] = ABP_OBJ_NUM_ANB
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_INSTANCE] = 1
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = ABP_MSG_HEADER_C_BIT OR ABP_CMD_SET_ATTR
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = ABP_BOOL_SIZEOF
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_CMD_EXT] = ABP_ANB_IA_SETUP_COMPLETE
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = AB_TRUE
        work_arr[ABS_DO_MSG] = AB_TRUE
        work_arr[AB_CmdState] = MSG_DONE
      CASE MSG_DONE
        IF (work_arr[AB_INSTANCE_READ_REQUEST] = AB_TRUE) THEN
          work_arr[AB_INSTANCE_READ_REQUEST] = AB_FALSE
          work_arr[AB_START_MSG_HEADER_OUT + AB_SOURCE_ID_OUT] = work_arr[AB_READ_SOURCE_ID]
          work_arr[AB_START_MSG_HEADER_OUT + AB_OBJECT_OUT] = work_arr[AB_READ_OBJ_NUM]
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_INSTANCE] = work_arr[AB_READ_INST_NUM]
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = ABP_MSG_HEADER_C_BIT OR ABP_CMD_GET_ATTR
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 0
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_CMD_EXT] = work_arr[AB_READ_ATTR_NUM]
          work_arr[ABS_DO_MSG] = AB_TRUE
        ENDIF 
    ENDSELECT
    IF (work_arr[ABS_DO_MSG] = AB_TRUE) THEN
      'A new command has been posted to the Anybus - CC.
      'Increment counter for outstanding commands.
      INC work_arr[AB_OUTSTANDING_COMMANDS]
    ENDIF
  ENDIF
  IF (work_arr[ABS_DO_MSG] = AB_TRUE) THEN
    IF (Write_Msg_To_Anybus(module,work_arr, flowrate) = AB_TRUE) THEN
      work_arr[ABS_DO_MSG] = AB_FALSE
    endif
  ENDIF
  IF ((work_arr[ABP_STATUS_REGISTER_IDX] AND ABS_BIT_ANB_STAT_S) = ABP_ANB_STATE_PROCESS_ACTIVE) THEN
    '      'The "read process data" is only valid in the PROCESS_ACTIVE state.
    '      'Retrieve the new "read process data" from the Anybus - CC.
    IF((work_arr[ABP_BUFFER_CONTROL_IDX] AND ABP_BIT_RDPD) = ABP_BIT_RDPD) THEN
      P2_M40_GET_RAM(module,in_pd_arr,1,ABP_PROCESS_DATA_READ_ADR,in_pd_arr_len,flowrate,32)   
      work_arr[ABP_TEMP_IDX] = ABP_BIT_RDPD 
    ELSE
      work_arr[ABP_TEMP_IDX] = 0
    ENDIF
    
    P2_M40_SET_RAM(module,out_pd_arr,1,ABP_PROCESS_DATA_WRITE_ADR,out_pd_arr_len,flowrate,32)   
    work_arr[ABP_TEMP_IDX] =  work_arr[ABP_TEMP_IDX] + ABP_BIT_WRPD + ABP_BIT_APPR
    P2_M40_SET_RAM(module,work_arr,ABP_TEMP_IDX,ABP_BUFFER_CONTROL_ADR,1,flowrate,16)                   'Procedata refresh
    work_arr[ABS_SPI_CTRL] = work_arr[ABS_SPI_CTRL] OR ABS_BIT_SPI_CTRL_PD_VALID
  ENDIF
  
  Run_ANYBUS_CC_M40 = work_arr[ABP_STATUS_REGISTER_IDX] AND ABS_BIT_ANB_STAT_S

ENDFUNCTION

'***************************************************************
'''Reads and writes process data from/to EtherCat module and 
'''+handles mailbox communication to the module.
'''+return value:
'''+         0: Setup
'''+         2: Wait
'''+         3: Idle
'''+         4: Active
'''+     other: Error (configuration correct?)
'''module:         module address (1..15)
'''in_pd_arr[]:    array for input data from EtherCAT bus
'''out_pd_arr[]:   array with output data to EtherCAT bus
'''in_pd_arr_len:  number (1..360) of input elements
'''out_pd_arr_len: number (1..360) of output elements
'''work_arr[]:     array for communication ADwin processor <-> EtherCat module
'''+ min. size AB_WORK_ARR_LEN 
'''flowrate: 
'''+         1=low
'''+         2=medium
'''+         3=fast
'''***************************************************************
FUNCTION P2_Run_Ethercat(module,in_pd_arr[], out_pd_arr[], in_pd_arr_len, out_pd_arr_len, work_arr[],flowrate) AS LONG
  P2_Run_ETHERCAT = Run_ANYBUS_CC_M40(module,out_pd_arr, in_pd_arr,in_pd_arr_len, out_pd_arr_len, work_arr,flowrate)
ENDFUNCTION


'***************************************************************
'''Reads and writes process data from/to ProfinetIO module and 
'''+handles mailbox communication to the module.
'''+return value:
'''+         0: Setup
'''+         2: Wait
'''+         3: Idle
'''+         4: Active
'''+     other: Error (configuration correct?)
'''module:         module address (1..15)
'''in_pd_arr[]:    array for input data
'''out_pd_arr[]:   array with output data
'''in_pd_arr_len:  number of in elements (1,2,4,8,16,32,64,128,196,256,320) in double words
'''out_pd_arr_len: number of out elements (1,2,4,8,16,32,64,128,196,256,320) in double words
'''work_arr[]:     array for communication ADwin processor <-> ProfinetIO module 
'''+ min. size AB_WORK_ARR_LEN 
'''flowrate: 
'''+         1=low
'''+         2=medium
'''+         3=fast
'''***************************************************************
FUNCTION P2_Run_ProfinetIO(module,in_pd_arr[], out_pd_arr[], in_pd_arr_len, out_pd_arr_len, work_arr[],flowrate) AS LONG
  P2_Run_ProfinetIO = Run_ANYBUS_CC_M40(module,out_pd_arr, in_pd_arr,  out_pd_arr_len, in_pd_arr_len, work_arr,flowrate)
ENDFUNCTION

'***************************************************************
'''Reads and writes process data from/to Profibus-40 module and 
'''+handles mailbox communication to the module.
'''+return value:
'''+         0: Setup
'''+         2: Wait
'''+         3: Idle
'''+         4: Active
'''+     other: Error (configuration correct?)
'''module:         module address (1..15)
'''in_pd_arr[]:    array for input data
'''out_pd_arr[]:   array with output data
'''in_pd_arr_len:  number of input elements (1,2,4,8,16,32,61) in double words
'''out_pd_arr_len: number of output elements (1,2,4,8,16,32,61) in double words
'''work_arr[]:     array for communication ADwin processor <-> Profibus-40 module 
'''+ min. size AB_WORK_ARR_LEN 
'''flowrate: 
'''+         1=low
'''+         2=medium
'''+         3=fast
'''***************************************************************
FUNCTION P2_Run_Profibus_M40(module,in_pd_arr[], out_pd_arr[], in_pd_arr_len, out_pd_arr_len, work_arr[],flowrate) AS LONG
  P2_Run_PROFIBUS_M40 = Run_ANYBUS_CC_M40(module,out_pd_arr, in_pd_arr, out_pd_arr_len, in_pd_arr_len, work_arr,flowrate)
ENDFUNCTION
  
FUNCTION Write_Msg_To_Anybus(module,work_arr[],flowrate) AS LONG   ''<HIDE>
  dim i as long
  work_arr[ABS_SPI_MSG_SIZE] = AB_HEADER_SIZE + work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] 
  work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_SOURCE_ID_OBJ] = SHIFT_LEFT(work_arr[AB_START_MSG_HEADER_OUT + AB_OBJECT_OUT], 8) OR work_arr[AB_START_MSG_HEADER_OUT + AB_SOURCE_ID_OUT]
  P2_M40_SET_RAM(module,work_arr,AB_START_MSG_HEADER_OUT,ABP_MSG_DATA_WRITE_ADR,work_arr[ABS_SPI_MSG_SIZE],flowrate,16)                   'Message 
  work_arr[ABP_TEMP_IDX] = ABP_BIT_WRMSG + ABP_BIT_APPR
  P2_M40_SET_RAM(module,work_arr,ABP_TEMP_IDX,ABP_BUFFER_CONTROL_ADR,1,flowrate,16)                   'Message ACK
  Write_Msg_To_Anybus = AB_TRUE
ENDFUNCTION

FUNCTION ApplicationObject(work_arr[]) AS LONG      ''<HIDE>
  ApplicationObject = AB_TRUE
  SELECTCASE work_arr[AB_START_MSG_HEADER_IN + AB_MSG_INSTANCE]
    CASE 1
      SELECTCASE work_arr[AB_START_MSG_HEADER_IN + AB_MSG_COMMAND] AND ABP_MSG_HEADER_CMD_BITS
        CASE ABP_CMD_GET_ATTR
          SELECTCASE (work_arr[AB_START_MSG_HEADER_IN + AB_MSG_CMD_EXT] AND 0FFH)
            CASEELSE
              work_arr[AB_ERROR_BASE] = AB_ERROR_CODE_ATTR_NOT_GETTABLE
              ApplicationObject = AB_FALSE
          ENDSELECT 
        CASE ABP_CMD_SET_ATTR
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 0
        CASEELSE
          work_arr[AB_ERROR_BASE] = AB_ERROR_CODE_UNSUP_COMMAND
          ApplicationObject = AB_FALSE
      ENDSELECT
    CASEELSE
      work_arr[AB_ERROR_BASE] = AB_ERROR_CODE_UNSUP_INSTANCE
      ApplicationObject = AB_FALSE
  ENDSELECT 
ENDFUNCTION 


FUNCTION ApplicationDataObject(work_arr[]) AS LONG      ''<HIDE>
  DIM i AS LONG
  ApplicationDataObject = AB_TRUE
  SELECTCASE work_arr[AB_START_MSG_HEADER_IN + AB_MSG_INSTANCE]
    CASE ABP_INST_OBJ
      SELECTCASE work_arr[AB_START_MSG_HEADER_IN + AB_MSG_COMMAND] AND ABP_MSG_HEADER_CMD_BITS
        CASE ABP_CMD_GET_ATTR
          SELECTCASE (work_arr[AB_START_MSG_HEADER_IN + AB_MSG_CMD_EXT] AND 0FFH)
            CASE ABP_OA_NAME
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 65         '"Application data"
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 1] = 112
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 2] = 112
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 3] = 108
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 4] = 105
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 5] = 99
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 6] = 97
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 7] = 116
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 8] = 105
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 9] = 111
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 10] = 110
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 11] = 32
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 12] = 100
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 13] = 97
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 14] = 116
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 15] = 97
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 32
            CASE ABP_OA_REV
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 1
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = ABP_OA_REV_DS
            CASE ABP_OA_NUM_INST
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] =  work_arr[AB_MAPPING_CNT_OUT] + work_arr[AB_MAPPING_CNT_IN]     
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = ABP_OA_NUM_INST_DS
            CASE ABP_OA_HIGHEST_INST
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] =  work_arr[AB_MAPPING_CNT_OUT] + work_arr[AB_MAPPING_CNT_IN]      
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = ABP_OA_HIGHEST_INST_DS
            CASE 11          'No mappabel read data
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 0
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 2
            CASE 12          'No mappabel write data
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 0
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 2
            CASEELSE
              work_arr[AB_ERROR_BASE] = AB_ERROR_CODE_ATTR_NOT_GETTABLE
              ApplicationDataObject = AB_FALSE
          ENDSELECT 
        CASE ABP_APPD_CMD_GET_INST_BY_ORDER
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_CMD_EXT] = work_arr[AB_START_MSG_HEADER_IN + AB_MSG_CMD_EXT]
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = work_arr[AB_START_MSG_HEADER_IN + AB_MSG_CMD_EXT] 
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 2
        CASE ABP_APPD_CMD_GET_INST_NUMBERS
          FOR i = 1 TO work_arr[AB_START_MSG_HEADER_IN + AB_MSG_DATA + 1]
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + (i-1)] = i
          NEXT i
        CASEELSE
          work_arr[AB_ERROR_BASE] = AB_ERROR_CODE_UNSUP_COMMAND
          ApplicationDataObject = AB_FALSE
      ENDSELECT
    CASEELSE
      SELECTCASE work_arr[AB_START_MSG_HEADER_IN + AB_MSG_COMMAND] AND ABP_MSG_HEADER_CMD_BITS
        CASE ABP_CMD_GET_ATTR
          SELECTCASE (work_arr[AB_START_MSG_HEADER_IN + AB_MSG_CMD_EXT] AND 0FFH)
            case ABP_APPD_CMD_GET_ATTR_NAME
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 050H
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 1] = 061H
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 2] = 072H
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 3] = 061H
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 4] = 06DH
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 5] = (030H + work_arr[AB_START_MSG_HEADER_IN + AB_MSG_INSTANCE])
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 6
            case ABP_APPD_CMD_GET_ATTR_DATA_TYPE
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = work_arr[AB_MAPPING_DATA_TYPE]
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 1
            case ABP_APPD_CMD_GET_ATTR_NO_ELEMENTS
              IF (work_arr[AB_START_MSG_HEADER_IN + AB_MSG_INSTANCE] <= work_arr[AB_MAPPING_CNT_IN]) THEN
                work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = work_arr[AB_MAPPING_SIZE_IN]
              ELSE
                work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = work_arr[AB_MAPPING_SIZE_OUT]
              ENDIF
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 1
            case ABP_APPD_CMD_GET_ATTR_DISCRIPTOR
              IF (work_arr[AB_START_MSG_HEADER_IN + AB_MSG_INSTANCE] <= work_arr[AB_MAPPING_CNT_IN]) THEN
                work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 09H             'Get access ; Mappable as write process data
              ELSE
                work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 013H            'Get access; Set access; Mappable as read process data
              ENDIF
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 1
            CASEELSE
              work_arr[AB_ERROR_BASE] = AB_ERROR_CODE_ATTR_NOT_GETTABLE
              ApplicationDataObject = AB_FALSE
          ENDSELECT 
      ENDSELECT 
  ENDSELECT 
ENDFUNCTION 
FUNCTION Check_Range_ETHERCAT(module,count, data_type, direction, work_arr[]) AS LONG      ''<HIDE>
  DIM size_adr AS LONG
  DIM cnt_adr AS LONG
  DIM type_size AS LONG
  IF (direction = AB_DIR_IN) THEN size_adr = AB_MAPPING_SIZE_IN
  IF (direction = AB_DIR_OUT) THEN size_adr = AB_MAPPING_SIZE_OUT
  IF (direction = AB_DIR_IN) THEN cnt_adr = AB_MAPPING_CNT_IN
  IF (direction = AB_DIR_OUT) THEN cnt_adr = AB_MAPPING_CNT_OUT
  Check_Range_ETHERCAT = AB_FALSE
  work_arr[AB_MODUL_NUMBER] = module
  type_size = -1
  IF (data_type = AB_DATA_TYPE_UINT32) THEN type_size = 4
  IF (data_type = AB_DATA_TYPE_FLOAT) THEN type_size = 4
  IF (data_type = AB_DATA_TYPE_SINT32) THEN type_size = 4
  IF (((count * type_size) >= 0) AND ((count * type_size) <=1440))THEN
    Check_Range_ETHERCAT = AB_TRUE
    work_arr[AB_MAPPING_DATA_TYPE] = data_type
    work_arr[size_adr] = 001H
    work_arr[cnt_adr] = count
  ENDIF
ENDFUNCTION

FUNCTION Check_Range_PROFIBUS(module, dev_adr,count,  direction, work_arr[]) AS LONG      ''<HIDE>
  DIM size_adr AS LONG
  DIM cnt_adr AS LONG
  DIM type_size AS LONG
  IF (direction = AB_DIR_IN) THEN size_adr = AB_MAPPING_SIZE_IN
  IF (direction = AB_DIR_OUT) THEN size_adr = AB_MAPPING_SIZE_OUT
  IF (direction = AB_DIR_IN) THEN cnt_adr = AB_MAPPING_CNT_IN
  IF (direction = AB_DIR_OUT) THEN cnt_adr = AB_MAPPING_CNT_OUT
  work_arr[AB_MAPPING_DATA_TYPE] = AB_DATA_TYPE_UINT32
  work_arr[AB_USER_BUS_TYPE] = ABP_OBJ_NUM_DPV1
  Check_Range_PROFIBUS = AB_FALSE
  work_arr[AB_MAPPING_DEV_ADR] = dev_adr
  work_arr[AB_MODUL_NUMBER] = module
  work_arr[cnt_adr] = 1
  IF (count = 001H) THEN
    Check_Range_PROFIBUS = AB_TRUE
    work_arr[size_adr] = 001H
  ENDIF
  IF (count = 002H) THEN 
    Check_Range_PROFIBUS = AB_TRUE
    work_arr[size_adr] = 002H
  ENDIF
  IF (count = 004H) THEN 
    Check_Range_PROFIBUS = AB_TRUE
    work_arr[size_adr] = 004H
  ENDIF
  IF (count = 008H) THEN 
    Check_Range_PROFIBUS = AB_TRUE
    work_arr[size_adr] = 008H
  ENDIF
  IF (count = 010H) THEN 
    Check_Range_PROFIBUS = AB_TRUE
    work_arr[size_adr] = 010H
  ENDIF
  IF (count = 020H) THEN
    Check_Range_PROFIBUS = AB_TRUE
    work_arr[size_adr] = 020H
  ENDIF
  IF (count = 03DH) THEN
    Check_Range_PROFIBUS = AB_TRUE
    'work_arr[cnt_adr] = 2
    work_arr[size_adr] = 03DH
  ENDIF
ENDFUNCTION

FUNCTION Check_Range_PROFINET(module, count, direction, work_arr[]) AS LONG      ''<HIDE>
  DIM size_adr AS LONG
  DIM cnt_adr AS LONG
  IF (direction = AB_DIR_IN) THEN size_adr = AB_MAPPING_SIZE_IN
  IF (direction = AB_DIR_OUT) THEN size_adr = AB_MAPPING_SIZE_OUT
  IF (direction = AB_DIR_IN) THEN cnt_adr = AB_MAPPING_CNT_IN
  IF (direction = AB_DIR_OUT) THEN cnt_adr = AB_MAPPING_CNT_OUT
  work_arr[AB_MAPPING_DATA_TYPE] = AB_DATA_TYPE_UINT32
  work_arr[AB_USER_BUS_TYPE] = ABP_OBJ_NUM_PNIO
  Check_Range_PROFINET = AB_FALSE
  work_arr[AB_MODUL_NUMBER] = module
  work_arr[cnt_adr] = 1
  IF (count = 001H) THEN
    Check_Range_PROFINET = AB_TRUE
    work_arr[size_adr] = 001H
  ENDIF
  IF (count = 002H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[size_adr] = 002H
  ENDIF
  IF (count = 004H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[size_adr] = 004H
  ENDIF
  IF (count = 008H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[size_adr] = 008H
  ENDIF
  IF (count = 010H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[size_adr] = 010H
  ENDIF
  IF (count = 020H) THEN
    Check_Range_PROFINET = AB_TRUE
    work_arr[size_adr] = 020H
  ENDIF
  IF (count = 040H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[size_adr] = 040H
  ENDIF
  IF (count = 080H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[cnt_adr] = 2
    work_arr[size_adr] = 040H
  ENDIF
  IF (count = 0C0H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[cnt_adr] = 3
    work_arr[size_adr] = 040H
  ENDIF
  IF (count = 0100H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[cnt_adr] = 4
    work_arr[size_adr] = 040H
  ENDIF
  IF (count = 0140H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[cnt_adr] = 5
    work_arr[size_adr] = 040H
  ENDIF
ENDFUNCTION

'***************************************************************
'''Initializes datas and variables for the communication to the 
'''+ProfinetIO module.
'''+return value:
'''+          0: OK
'''+         -1: Wrong no of IO data elements
'''module: module address (1..15)
'''in_mod_cnt:  number of in elements (1,2,4,8,16,32,64,128,196,256,320) in double words
'''out_mod_cnt: number of out elements (1,2,4,8,16,32,64,128,196,256,320) in double words
'''work_arr[]:  array for communication ADwin processor <-> ProfinetIO module 
'''+ min. size AB_WORK_ARR_LEN 
'''***************************************************************
'''#C;LOW;
FUNCTION P2_Init_ProfinetIO(module,in_mod_cnt, out_mod_cnt, work_arr[]) AS LONG
  DIM check_result AS LONG
  check_result =  Check_Range_PROFINET(module,in_mod_cnt,  AB_DIR_IN, work_arr) AND Check_Range_PROFINET(module,out_mod_cnt,  AB_DIR_OUT, work_arr) 
  P2_Init_ProfinetIO = Init_ANYBUS_CC_M40(module,in_mod_cnt, out_mod_cnt,AB_DATA_TYPE_UINT32 , check_result, work_arr) 
ENDFUNCTION
'***************************************************************
'''Initializes datas and variables for the communication to the 
'''+EtherCat module.
'''+return value:
'''+          0: OK
'''+         -1: Wrong IO size; the size of process data in and 
'''+             process data out must each be in the range of 0 .. 1440 byte
'''module: module address (1..15)
'''in_mod_cnt:  number (0..360) of in elements in double words
'''out_mod_cnt: number (0..360) of out elements in double words
'''data_type:   data type of process data in and process data out
'''+            [AB_DATA_TYPE_UINT32: unsigned integer, 32bit]
'''+            AB_DATA_TYPE_SINT32: signed integer, 32bit
'''+            AB_DATA_TYPE_FLOAT: floating point, 32bit
'''work_arr[]:  array for communication ADwin processor <-> EtherCAT module 
'''+ min. size AB_WORK_ARR_LEN 
'''***************************************************************
'''#C;LOW;
FUNCTION P2_Init_EtherCat(module,in_mod_cnt, out_mod_cnt, data_type, work_arr[]) AS LONG
  DIM check_result AS LONG
  check_result =  Check_Range_ETHERCAT(module,in_mod_cnt, data_type, AB_DIR_IN, work_arr) AND Check_Range_ETHERCAT(module,out_mod_cnt, data_type, AB_DIR_OUT, work_arr) 
  P2_Init_ETHERCAT = Init_ANYBUS_CC_M40(module,in_mod_cnt, out_mod_cnt, data_type, check_result, work_arr) 
ENDFUNCTION

'***************************************************************
'''Initializes arrays and variables for the communication to the 
'''+Profibus-40 module.
'''+return value:
'''+          0: OK
'''+         -1: Wrong IO size; the size of process data in and process data out
'''module: module address (1..15)
'''dev_adr: node ID (1..125)
'''in_mod_cnt:  number of in elements (1,2,4,8,16,32,61)
'''out_mod_cnt: number of out elements (1,2,4,8,16,32,61)
'''work_arr[]:  array for communication ADwin processor <-> Profibus-40 module 
'''+ min. size AB_WORK_ARR_LEN 
'''***************************************************************
'''#C;LOW;
FUNCTION P2_Init_Profibus_M40(module,dev_adr,in_mod_cnt, out_mod_cnt,  work_arr[]) AS LONG
  DIM check_result AS LONG
  check_result =  Check_Range_PROFIBUS(module,dev_adr,in_mod_cnt,  AB_DIR_IN, work_arr) AND Check_Range_PROFIBUS(module,dev_adr,out_mod_cnt,  AB_DIR_OUT, work_arr) 
  P2_Init_PROFIBUS_M40 = Init_ANYBUS_CC_M40(module,in_mod_cnt, out_mod_cnt, AB_DATA_TYPE_UINT32, check_result, work_arr) 
ENDFUNCTION

'***************************************************************
'''Initializes datas and variables for the communication to the 
'''+Anybus module.
'''+return value:
'''+         0: OK
'''+         -1: Wrong no of IO data elements
'''module: module address (1..15)
'''in_mod_cnt: number of in elements {1,2,4,8,16,32,64,128,196,256,320}
'''out_mod_cnt: number of out elements {1,2,4,8,16,32,64,128,196,256,320}
'''data_type: ???
'''check_result: ???
'''work_arr[]: array for communication ADwin processor <-> Anybus module 
'''+ min. size AB_WORK_ARR_LEN 
'''***************************************************************
'''#C;LOW;
FUNCTION Init_ANYBUS_CC_M40(module,in_mod_cnt, out_mod_cnt, data_type, check_result, work_arr[]) AS LONG     ''<HIDE>
  DIM i AS LONG
  Check_Type_Long (work_arr[1])
  System_Array_Debug_Check(work_arr,1,AB_WORK_ARR_LEN)

#if Prioritaet = low
  IF (check_result = AB_FALSE) THEN
    Init_ANYBUS_CC_M40 = -1
  ELSE
    Init_ANYBUS_CC_M40 = 0
  
    P2_ABM40_Reset(module)
    FOR i = 1 TO AB_WORK_ARR_LEN
      IF ((i < AB_MAPPING_CNT_IN) OR (i > AB_USER_BUS_TYPE))THEN work_arr[i] = 0
    NEXT i

    work_arr[ABS_SPI_CTRL] = ABS_BIT_CMDCNT
    work_arr[AB_PROC_TYPE_IN] = data_type
    work_arr[AB_PROC_CNT_IN] = in_mod_cnt
    work_arr[AB_PROC_TYPE_OUT] = data_type 
    work_arr[AB_PROC_CNT_OUT] = out_mod_cnt
    work_arr[AB_CmdState] = MSG_INIT
    work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = AB_TRUE
    work_arr[ABS_SPI_STATE] = ABS_SPI_STATE_INIT
    work_arr[ABS_SPI_APP_STATE] = 0
    work_arr[ABS_SPI_INT_MASK] = 0
  ENDIF
#else
  Error_If_High("the command Init_ProfinetIO can only be used in low priority section ")
#endif
ENDFUNCTION

SUB Request_Attribute(Source_ID, Object, Instance, Attribute, work_arr[])      ''<HIDE>
  work_arr[AB_INSTANCE_READ_REQUEST] = AB_TRUE
  work_arr[AB_READ_SOURCE_ID] = Source_ID
  work_arr[AB_READ_OBJ_NUM] = Object
  work_arr[AB_READ_INST_NUM] = Instance
  work_arr[AB_READ_ATTR_NUM] = Attribute
ENDSUB
FUNCTION Read_Attribute(response_array[], work_arr[]) AS LONG      ''<HIDE>
  DIM i AS LONG
  Read_Attribute = AB_FALSE
  IF (work_arr[AB_START_MSG_HEADER_IN + AB_SOURCE_ID_OUT] = work_arr[AB_READ_SOURCE_ID]) THEN
    FOR i = 0 TO (work_arr[AB_START_MSG_HEADER_IN + AB_MSG_DATA_SIZE]/2) 
      response_array[i + 1] = work_arr[AB_START_MSG_HEADER_IN + AB_MSG_DATA + i]
    NEXT i
    Read_Attribute = AB_TRUE
  ENDIF
ENDFUNCTION 



'<ENDREGION>

'<REGION> COMP 16

'''Sets hysteresis switch points for a channel group
'''+Read comparator bits with instructions for digital inputs e.g. P2_Digin_Long.
'''+With hold/standard hysteresis, bits refer to channels as follows:
'''+       Bit no.       15, 14, .. 1, 0
'''+       Channel no.   15, 14, .. 1, 0
'''+With 2 channel hysteresis, bits refer to channels as follows:
'''+       Bit no.         23,   22,   .. 17,  16
'''+       Channel pair  15/14, 13/12, .. 3/2, 1/0
'''module: module address (1..15)
'''ch_group: channel group (1..4)
'''+      1: Channels 0,2,4,6
'''+      2: Channels 1,3,5,7
'''+      3: Channels 8,10,12,14
'''+      4: Channels 9,11,13,15 
''' volt: output value in volts -1V..30V
'''******************************************************************************
SUB P2_Comp_Set_Voltage(module, ch_group, volt) 
  dim value as long
  check_card(module)
  value = 32768 + (volt) * 65536 / 60                       

#if prozessor=t12   
  POKE ((60022FF0h + (ch_group) * 16) OR shift_left(module, 20), value)
#else
  POKE_FAST_BUS(((320022FFh + ch_group) OR shift_left(module, 16)), value)
#endif


ENDSUB




'<ENDREGION>

'<REGION> System 

sub p2_System_PROII_Bus_Set_Timeout() '<HIDE>
  
#if prozessor=t11 
  poke(10000500h,80) 'nicht kleiner stellen!
  POKE_FAST_BUS(3200FFF0h, 4)                    
#endif

#if prozessor=t12
  poke(50005000h,160)
  poke(syst_hw_nop, 4)                
#endif
  
endsub  
  
  
'<ENDREGION>

'<REGION> IEPE
'''Initializes the IEPE module.
'''module: module address (1..15)
'''filter_pattern: low-pass filter pattern each bit set one channel 
'''+    Bit 0: Channel 1, ... Bit 7: Channel 8
'''+    bit=0: TP 1.5 KHz
'''+    bit=1: TP 15 KHz
'''power_enable: Power enable
'''+ 0 VCC OFF (IEPE Power OFF)  
'''+ 1 VCC  ON (I Current 4mA, max. 28V DC)
''' acdc: 
'''+ 0 AC (IEPE mode)
'''+ 1 DC Mode (Power Enable for all Channels OFF) 
SUB P2_IEPE_Init(module,filter_pattern,power_enable, acdc)
  dim h as long
  CHECK_CARD(module)
  
#if prozessor=t11
  POKE_FAST_BUS((32807350h OR shift_left(module, 16)), filter_pattern)
#else
  POKE((68073500h OR shift_left(module, 20)),filter_pattern)
#endif

  
  h=power_enable 'xor 1
    
  
#if prozessor=t11
  POKE_FAST_BUS((32807360h OR shift_left(module, 16)), h)
#else
  POKE((68073600h OR shift_left(module, 20)),h)
#endif
  '
       
#if prozessor=t11
  POKE_FAST_BUS((32807370h OR shift_left(module, 16)), ACDC)
#else
  POKE((68073700h OR shift_left(module, 20)),ACDC)
#endif
  
ENDSUB



'''Returns the error status of the IEPE module as a bit pattern.
'''+ IEPE Power must be enabled to return correct status values, see P2_IEPE_Init
'''+ bit = 1: error has occurred; bit = 0: no error
'''+ Bit 0: Channel 1, short-circuit (= input <1V)
'''+ Bit 1: Channel 1, broken cable (= input >23V)
'''+ ...
'''+ Bit 14: Channel 8, short-circuit (= input <1V)
'''+ Bit 15: Channel 8, broken cable (= input >23V)
'''module: module address (1..15)
FUNCTION P2_IEPE_Status(module) as long
  CHECK_CARD(module)
  
#if prozessor=t11
  SUB_BEGIN_CRITICAL_SECTION
  POKE_FAST_BUS((33807352h OR shift_left(module, 16)), 0)
  READ_FAST_BUS(P2_IEPE_STATUS, 1)
  SUB_END_CRITICAL_SECTION
#else
  P2_IEPE_STATUS=peek_p2(68073520h OR shift_left(module, 20))
  
  'POKE((68073520h OR shift_left(1, 20)),1) 'muss wieder weg
#endif
    
ENDFUNCTION


'<ENDREGION>



